// FILE: ./assets/js/utilities/FAIUtilities.js
var FAIUtilities = function (ScreenService, templateManager, General, $rootScope, ZHPromise, ZhFilterPreferences, ZhPreferences, Query, metaDataFactory, restEngine) {
    
    var reportFormats = [
        {
            "name" : "pdf",
            "value": "PDF"
        },
        {
            "name" : "xlsx",
            "value": "XLSX"
        }
    
    ];

    
    /*global Configuration, getLocalVar, moment, angular, Util, */
    //Filter
   /*
    ZhFilterPreferences.oldApplyFilter = ZhFilterPreferences.applyFilter;
    ZhFilterPreferences.applyFilter = function (widget, filter, reloadWidget) {
        return ZhFilterPreferences.oldApplyFilter(widget, filter, reloadWidget).then(function (widgetPromiseReturn) {
           if (reloadWidget !== false) {
               updateStripe(widget);
           }
        }.bind(this));
    };
    */

    /*var updateStripe = function (gridWidget) {
        return handleStripe(gridWidget).then(function () {
            var filterInfo = gridWidget.__filterInfoStripe;
            deleteUsedFilterParameterOnStripeFields(filterInfo);
            setFieldsByFilterOnStripe(gridWidget._filterInfo, filterInfo);
            hideFieldsNotUsedOnStripe(filterInfo);
            activateCollapseButtonByVisibleFieldsOnStripe(filterInfo);
        });
    };*/
    //this.updateStripe = updateStripe;

    /**
     * Deleta o parâmetro que indica quando uma field do stripe
     * já foi usada para exibir indormações do filtro definido
     * (em todos os fields do stripe).
     * 
     * @param {object} stripe widgtet stripe.
     */

/*    function deleteUsedFilterParameterOnStripeFields(stripe) {

        stripe.fields.forEach(function (field) {

            if (field.hasOwnProperty("usedFiedlOnStripe")) {
                delete field.usedFiedlOnStripe;
            }

        });

    }
*/
    /**
     * Define a rotina para exibir os valores filtrados
     * no stripe, onde "OBJECTS_BY_LABEL_ON_STRIPE" e a variável
     * que define o máximo de informações do filtro atual a serem
     * setadas por field.
     * 
     * @param {object} filterInfo informações do filtro
     * definido na widget.
     * 
     * @param {object} stripe widgtet stripe.
     */
    /*function setFieldsByFilterOnStripe(filterInfo, stripe) {

        if (!Util.isEmptyOrBlank(filterInfo)) {

            var validfilterInfo = getValidFilterInfo(filterInfo);

            var OBJECTS_BY_LABEL_ON_STRIPE = 3;
            var filterInfoLength = validfilterInfo.length;

            if (filterInfoLength > OBJECTS_BY_LABEL_ON_STRIPE) {

                buildStripeField(validfilterInfo.slice(0, 3), stripe);
                setFieldsByFilterOnStripe(validfilterInfo.slice(3), stripe);

            } else if (filterInfoLength > 0) {
                buildStripeField(validfilterInfo, stripe);
            }

        }

    }*/

    /**
     * Retonar um array com os valores válidos
     * a serem definidos no stripe, ou seja, retorna
     * apenas as informações que possuem label.
     * 
     * @param {object} filterInfo informações do filtro
     * definido na widget.
     */
    /*function getValidFilterInfo(filterInfo) {

        let labelsToExclude = ["TODAS", "TODOS"];
        let validFilterInfo = [];
        if (isSavedFilter(filterInfo)) {
            validFilterInfo.push({
                label: "Filtro Aplicado",
                value: filterInfo[0].filterName
            });
        } else {
            validFilterInfo = filterInfo.filter(function (filterInfo) {
                let valueIsFilled = (!Util.isEmptyOrBlank(filterInfo.value));
                let labelIsFilled = (!Util.isEmptyOrBlank(filterInfo.label));
    
                let upperCaseLabel = filterInfo.label.toUpperCase();
                let labelIsNotInExcludeList = (labelsToExclude.indexOf(upperCaseLabel) == -1);
    
                return (valueIsFilled && labelIsFilled && labelIsNotInExcludeList);
            });
        }
        return validFilterInfo;
    }*/

    /*function isSavedFilter(filterInfo) {
        return filterInfo.length && filterInfo[0] && filterInfo[0].filterName;
    }*/

    /**
     * Cria um field, ou utiliza um já existente,
     * para ser definido no stripe.
     * 
     * @param {object} filterInfo informações do filtro
     * definido na widget.
     * 
     * @param {object} stripe widgtet stripe.
     */
   /* function buildStripeField(filterInfo, stripe) {

        var stripeFields = stripe.fields;
        var availableFieldIndex = getAvailableFieldIndex(stripeFields);

        if (availableFieldIndex !== undefined) {

            var stripeField = stripeFields[availableFieldIndex];
            var fieldLabel = buildStripeFielLabelByFilterInfo(filterInfo, stripe);
            stripeField.label = fieldLabel;

            if (stripeField.isVisible === false) {
                stripeField.isVisible = true;
            }

        } else {
            stripeFields.push(buildFieldForStripe(filterInfo, stripe));
        }

    }*/

    /**
     * Retonar o index de um field que ainda não foi utilizado,
     * no stripe, para exibir valores do filtro.
     * 
     * @param {object} stripeFields fields existentes no stripe.
     */
    /*function getAvailableFieldIndex(stripeFields) {

        if (stripeFields !== undefined && stripeFields.length > 0) {
            for (var i = 0; i < stripeFields.length; i++) {
                if (!Boolean(stripeFields[i].usedFiedlOnStripe)) {
                    stripeFields[i].usedFiedlOnStripe = true;
                    return i;
                }
            }
        }
        return undefined;
    }*/

    /**
     * Cria um field para exibir informações do filtro
     * no stripe.
     * 
     * @param {object} filterInfo informações do filtro
     * definido na widget.
     * 
     * @param {object} stripe widgtet stripe.
     */
    /*function buildFieldForStripe(filterInfo, stripe) {

        var fieldLabel = buildStripeFielLabelByFilterInfo(filterInfo);

        var field = {
            name: "STRIPE_FIELD",
            label: fieldLabel,
            widget: stripe,
            usedFiedlOnStripe: true
        };

        return metaDataFactory.fieldFactory(field);

    }*/

    /**
     * Cria o texto que será definido na label de um field
     * no stripe.
     * 
     * @param {object} filterInfo informações do filtro
     * que serão utilizadas para montar o texto.
     */
   /* function buildStripeFielLabelByFilterInfo(filterInfo) {

        var fieldLabel;

        if (filterInfo.length === 1) {
            fieldLabel = ScreenService.i18n(filterInfo[0].label) + ": " + filterInfo[0].value;
        } else {

            fieldLabel = filterInfo.reduce(function (acc, cur) {
                return acc + ScreenService.i18n(cur.label) + ": " + cur.value + "   •   ";
            }, "");
            fieldLabel = fieldLabel.replace(/   •   ([^   •   ]*)$/, '$1');

        }

        return fieldLabel;

    }*/

    /**
     * Oculta fields que não são usandos no stripe.
     * 
     * @param {object} stripe widget stripe.
     */
    /*function hideFieldsNotUsedOnStripe(stripe) {

        stripe.fields.forEach(function (field) {

            if (!field.hasOwnProperty("usedFiedlOnStripe")) {
                field.isVisible = false;
            }

        });

    }*/

    /*function activateCollapseButtonByVisibleFieldsOnStripe(stripe) {

        var countStripeVisibleFields = 0;
        var NUMBER_OF_FIELDS_TO_SHOW_COLLAPSE_BUTTON = 3;
        var stripeFields = stripe.fields;

        stripeFields.forEach(function (field) {

            if (field.isVisible) {
                countStripeVisibleFields++;
            }

        });

        if (countStripeVisibleFields >= NUMBER_OF_FIELDS_TO_SHOW_COLLAPSE_BUTTON) {
            stripe.collapsible = true;
        } else {
            stripe.collapsible = false;
        }

    }*/

    /*var handleStripe = function (gridWidget) {
        var deferred = ZHPromise.defer();
        if (!gridWidget.__filterInfoStripe) {
            var stripeName = gridWidget.stripeToShowGridFilterInfo;
            if (stripeName) {
                var stripeWidget = templateManager.container.getWidget(stripeName);
                if (stripeWidget) {
                    if (~stripeWidget.template.indexOf("stripe.html")) {
                        var stripe = gridWidget.__filterInfoStripe = stripeWidget;
                        stripe.__stripeOriginalFields = stripe.fields;
                        factoryStripeFields([], gridWidget).then(function (fields) {
                            stripe.fields = fields;
                            deferred.resolve();
                        });
                    } else {
                        console.error("ZhGridFilter: Widget " + stripeName + " is not a Stripe");
                        deferred.reject();
                    }
                } else {
                    console.error("ZhGridFilter: There is no widget named " + stripeName);
                    deferred.reject();
                }
            }
        } else {
            deferred.resolve();
        }
        return deferred.promise;
    };*/

    /*var factoryStripeFields = function (fields, gridWidget) {
        var deferred = ZHPromise.defer();
        var stripe = gridWidget.__filterInfoStripe;
        fields = stripe.__stripeOriginalFields ? fields.concat(stripe.__stripeOriginalFields) : fields;
        var fieldsMap = fields.map(function (field) {
            var factoredField = metaDataFactory.fieldFactory(field);
            factoredField.widget = stripe;
            return factoredField;
        });
        deferred.resolve(fields);
        return deferred.promise;
    };*/

    this.startFilter = function (widget, currentRow) {
        return ZhPreferences.getDefaultWidgetPreferences(widget.id).then(function (result) {
            if (result && result.DEFAULT_FILTER) {
                ZhPreferences.getPreferences('filter', Query.build().where('WIDGET_ID').equals(widget.id)).then(function (filters) {
                    var defaultFilter = filters.filter(function (filter) {
                        return filter.ID == result.DEFAULT_FILTER;
                    })[0];
                    var filter = {
                        ID: defaultFilter.LABEL_TO_PREFERENCE || 'EDITED',
                        FILTER_ROW: JSON.parse(defaultFilter.FILTER_ROW)
                    };

                    currentRow = filter.FILTER_ROW;
                    
                    ZhFilterPreferences.applyFilter(widget, filter).then(function () {
                        widget.appliedFilter = widget.appliedFilter || filter;
                        widget.appliedFilter.ID = result.DEFAULT_FILTER;
                        if (defaultFilter.LABEL_TO_PREFERENCE) {
                            widget._filterInfo[0].value = defaultFilter.LABEL_TO_PREFERENCE;
                        }
                    });
                });
            } else {
                if (Util.isUndefinedOrNull(currentRow) || Util.isEmptyObject(currentRow)) {
                    currentRow = buildFilterCurrentRow(widget);
                }
            }
            return ZhFilterPreferences.openFilterWidget(widget, currentRow);
        });
    };

    /*var buildFilterCurrentRow = function (widget) {
        return getFilterRowWithDefaultValues(widget.fields);
    };*/

   /* var getFilterRowWithDefaultValues = function (filterFields) {
        let filterRow = {};
        filterFields.forEach(field => {
            let defaultValue = Util.getNestedProperty(field, ["filterProperties", "defaultValue"]) || field.defaultValue;
            if (!Util.isUndefinedOrNull(defaultValue)) {
                filterRow[field.name] = Util.evaluate(defaultValue);
            }
        });
        return filterRow;
    };*/
   /* var trataNumerico = function(value, decimalSeparator) {
        if (typeof value == "number") {
        return value.toString().split(".").join(decimalSeparator);
        }
        return (value) ? value.toString() : value + '';
        };*/
    /*
     * Usar no FieldOnKeydown
     *
     */
    
    /*this.lengthCurrency = function(args) {
        var value;
        var fieldValue;
        var field = args.owner.field;
        // var allowedKeys = [8, 9, 37, 38, 39, 40, 46, 44, 108, 188, 194];
        var allowedKeys = ['Tab', 'ArrowLeft', 'ArrowRight', 'ArrowUp', 'ArrowDown', 'End', 'Home', 'Shift', 'Control', 'Delete', 'Backspace', 'Alt'];

        let decimalSeparator = ',';
        let thousandSeparator = '.';

        if (field.mask && field.mask.params && field.mask.params.decimal) {
            decimalSeparator = field.mask.params.decimal;
        }

        if (field.mask && field.mask.params && field.mask.params.thousands) {
            thousandSeparator = field.mask.params.thousands;
        }

        if (field.inlineEditable && (field.widget.mode === "list" || field.widget.mode === "inline_edit")) {
            fieldValue = trataNumerico(field.widget.currentRow[field.name + '_inline'], decimalSeparator);
            fieldValue = fieldValue.toString();
            if (event.target.selectionStart !== event.target.selectionEnd) {
                fieldValue = fieldValue.substring(0, event.target.selectionStart) || fieldValue.substring(event.target.selectionEnd);
            }
            value = Util.isEmptyOrBlank(fieldValue) ? "" : fieldValue;
        } else {
            fieldValue = trataNumerico(field.value(), decimalSeparator);
            fieldValue = fieldValue.toString();
            if (event.target.selectionStart !== event.target.selectionEnd) {
                fieldValue = fieldValue.substring(0, event.target.selectionStart) || fieldValue.substring(event.target.selectionEnd);
            }
            value = Util.isEmptyOrBlank(fieldValue) ? "" : fieldValue;
        }

        fieldValue = fieldValue.toString();

        let posDecimalseparator = fieldValue.indexOf(decimalSeparator);

        if (event.target.selectionStart !== event.target.selectionEnd) {
            fieldValue = fieldValue.substring(0, event.target.selectionStart) || fieldValue.substring(event.target.selectionEnd);
        }

        let posInsertChar = event.target.selectionStart;

        var cleanNumber = value.split('-').join('').split('.').join('').split(',').join('');
        let numberArray = value.split('-').join('').split(thousandSeparator).join('').split(decimalSeparator);
        let realLength = numberArray[0].length;
        let decimalLength = 0;
        if(numberArray[1] && numberArray[1].length) 
            decimalLength = numberArray[1].length;
        
        var separador;
        //var decimalLength = value.split('-').join('').split('.').join('').split(',')[1] ? value.split('-').join('').split('.').join('').split(',')[1].length : 0;
        var precision = "d{0,5}";
        var precisionLength = 0;
        var regex = "^(\\d{1," + field.maxLengthCurrency + "})$";

        if (field.mask && field.mask.params && field.mask.params.precision) {
            precision = "d{1," + field.mask.params.precision + "}";
            regex = "^(\\d{1," + field.maxLengthCurrency + "})(\\,|\\.){1}(\\" + precision + ")$";
            precisionLength = field.mask.params.precision;
        }
        var validation = new RegExp(regex, "gm");
        
        /*
        if (last > -1) {
            separador = value.substring(0, last).length >= field.maxLengthCurrency - precisionLength ? ',' : value[last];
            value = value.substr(0, last).concat(separador + value.substr(last + 1, value.length));
            value = value.split('.').join('');
            last = value.lastIndexOf(',');
            realLength = value.substr(0, last).length;
            decimalLength = value.substr(last + 1, value.length).length;
        }
        */
        /*
        let isDecimalSeparator = (args.e.key === decimalSeparator);
        let allowDecimalSeparator = ((precisionLength > 0) && (!value.includes(decimalSeparator)));
        if (isDecimalSeparator && !allowDecimalSeparator) {
            args.e.preventDefault();
        }

        if (field.mask && field.mask.params && field.mask.params.thousands) {
            thousandSeparator = field.mask.params.thousands;
        }
        let isThousandSeparator = (args.e.key === thousandSeparator);

        if (isThousandSeparator) {
            args.e.preventDefault();
        }

        let allowNegative = true;
        if (field.mask && field.mask.params) {
            allowNegative = field.mask.params.allowNegative;
        }
        allowNegative = (allowNegative && !value.includes('-'));
        isNegativeSimbol = (args.e.key === '-');

        if (isNegativeSimbol && (!allowNegative || (event.target.selectionStart > 0))) {
            args.e.preventDefault();
        }
        if (!allowedKeys.includes(args.e.key) && !isNegativeSimbol && !isDecimalSeparator && !isThousandSeparator) {
            if (realLength >= field.maxLengthCurrency) {
                if ((posDecimalseparator < 0) || (posInsertChar <= posDecimalseparator))
                    args.e.preventDefault();
            }

            if ((posDecimalseparator >= 0) && (posInsertChar > posDecimalseparator) && (precisionLength == decimalLength)) {
                args.e.preventDefault();
            }
        }
    };*/
    
    /*function setValue (event, value){
        event.target.value = value;
    }*/
    
    /*this.checkFieldLength = function(field, convertToFloat = false) {
        var maxLength = field._maxSize;
        var precision = field._precision;
        var modeToTrunc = field._modeToTrunc ? field._modeToTrunc : 'END';
        var caracter = field._caracter;
        var allowNegative = field._allowNegative;
        var value = event.target.value;
        var oldValue = value;
        var absNumber = value.split('-').join('');
        value = allowNegative ? '-'+absNumber : absNumber;
        var obj = treatStrWithNaN(value, true, [',','.','-'],caracter);
        // field.setValue(obj.normalizedNumber);
        setValue(event, obj.normalizedNumber);
        templateManager.updateTemplate();
        var qtCharacteresNaN = obj.count; 
        value = obj.normalizedNumber;
        if(qtCharacteresNaN === oldValue.length){
            // field.setValue("");
            setValue(event, "");
            templateManager.updateTemplate();
        } else {
            if(!isNumber(event) &&  qtCharacteresNaN > 1 && value.length >= oldValue.length){
                let normalizedNumber = value.split('');
                normalizedNumber.pop();
                normalizedNumber = normalizedNumber.join('');
                // field.setValue(normalizedNumber);
                setValue(event, normalizedNumber);
                templateManager.updateTemplate();
            }
            if (value) {
                if(field.validToSave && !isValidNumberMask(value, maxLength, precision)){
                    var formatValue = formatarNumero(value, maxLength, precision, modeToTrunc, caracter);
                    formatValue = convertToFloat ? parseFloat(formatValue) : formatValue;
                    // field.clearValue();
                    setValue(event, "");
                    // field.setValue(formatValue);
                    setValue(event, formatValue);
                    field.reload();
                }
                field.validToSave = true;
            }else{
                if(!field.validToSave){
                    // field.clearValue();
                    setValue(event, "");
                    field.validToSave = true;
                }else{
                    field.validToSave = false;
                }
            }
        }
    };*/
    
    /*function isValidNumberMask(value, maxLength, precision){
        var formatNumber = getPartsNumber(value, precision, maxLength);
        var number = value && typeof value.toString === 'function' ? value.toString().split(',').join('').split('.').join('') : "";
        if(number.length <= maxLength && formatNumber.length === value.length){
            return true;
        }else{
            return false;
        }
    }*/
    
    /*var getPartsNumber = function(number, precision, maxLength,caracter) {
        var formatNumber = '';
        number = number.split(',').join('.');
        var numberClean = number.split('.').join('');
        var lastCharacter = number[number.length-1];
        var precisionUser = number.split('.').length > 1 ?  number.split('.')[1].length : 0; 
        if (typeof number === 'string' && typeof precision === 'number') {
            if(typeof maxLength === 'number' && (number.length-1)-precisionUser <= maxLength-precision && 
                precisionUser <= precision && 
            (
                (precisionUser !== 0) || (precisionUser === 0 && number.length <= maxLength-precision) || 
                (precisionUser === 0 && 
                    (number.length <= maxLength-precision || (numberClean.length <= maxLength-precision && lastCharacter === '.')))
            )
            ){
                formatNumber = number;
            }else{
                var part1 = number.substring(0, number.length - precision);
                var part2 = number.substring(number.length - precision, number.length);
                if (typeof caracter === 'string') {
                    formatNumber = part1 + caracter + part2;
                } else {
                    formatNumber = part1 + '.' + part2;
                }
            }
        }
        return formatNumber;
    };*/
    
    /*function isNumber(event){
        return (event.keyCode > 47 && event.keyCode < 58) || (event.keyCode > 95 && event.keyCode < 106);
    }*/
    
    /*function treatStrWithNaN(str, verifyAndNormalizeNumber, allowChar, caracter = '.'){
        let obj = {
            count: 0,
            normalizedNumber: ""
        };
        allowChar = Array.isArray(allowChar) ? allowChar : [];
        if(typeof str === 'string' && str.length){
            str.split('').forEach(function(caracter){
                obj.count += isNaN(caracter) ? 1 : 0;
                if(verifyAndNormalizeNumber) {
                    obj.normalizedNumber += isNaN(caracter) && allowChar.indexOf(caracter) === -1 ? "" : caracter;
                }
            });
        } 
        if(obj.normalizedNumber && caracter){
            obj.normalizedNumber = obj.normalizedNumber.split('.').join(caracter);
        }
        return obj;
    }*/
    
    /*var formatarNumero = function(value, maxLength, precision, modeToTrunc, caracter) {
        var arrayFromString;
        var number = value && typeof value.toString === 'function' ? value.toString().split(',').join('').split('.').join('') : "";
        if (number && typeof caracter === 'string') {
            number = number.split(caracter).join('');
        }
        if (typeof maxLength === 'number' && typeof precision === 'number') {
            if (number && number.length > maxLength) {
                do {
                    arrayFromString = number.split('');
                    if (modeToTrunc === 'END') {
                        number = number.substring(0, maxLength);
                    } else {
                        arrayFromString.shift();
                        number = arrayFromString.join('');
                    }
                } while (number.length > maxLength);
                number = getPartsNumber(number, precision, maxLength,caracter);
            } else if (number.length > precision) {
                number = getPartsNumber(number, precision, maxLength,caracter);
            } else if (number.length === precision){
                number = getPartsNumber(number.padStart(maxLength, '0'), precision);
                if(number[number.length-1] === '0'){
                    number = caracter ? parseFloat(number.split(',').join('.')).toString().split('.').join(caracter) : parseFloat(number.split(',').join('.')).toString();
                    number = number.padEnd(maxLength, '0');
                    return number;
                }
            }
        } else if (typeof precision === 'number') {
            number = getPartsNumber(number, precision, maxLength,caracter);
        } else if (typeof maxLength === 'number') {
            do {
                arrayFromString = number.split('');
                if (modeToTrunc === 'END') {
                    number = number.substring(0, maxLength);
                } else {
                    arrayFromString.shift();
                    number = arrayFromString.join('');
                }
            } while (number.length > maxLength);
        }
        number = caracter ? parseFloat(number.split(',').join('.')).toString().split('.').join(caracter) : parseFloat(number.split(',').join('.')).toString();
        return number;
    };*/
    
  /*  this.fillZero = function(field){
        let value = event.target.value;
        let precision = field._precision;
        if(value){
            let valueFloat = parseFloat(value.split(',').join('.'));
            valueFloat = valueFloat.toFixed(precision);
            valueFloat = valueFloat.split('.').join(',');
            setValue(event, valueFloat);
        }
    };*/
    /*function isSemicolon(event){
        return event.keyCode === 194 || event.keyCode === 190 || event.keyCode === 188 || event.keyCode === 110; //ponto ou virgula
    }*/
    /*this.onKeyDown = function(field){
        var obj = treatStrWithNaN(event.target.value, true, null, ',');
        var element = event.target;
        var isNumberValue = isNumber(event);
        if(!isKeysNavigationOrDelete(event) && !isNumberValue && !isSemicolon(event)){
            event.returnValue = false;
        } else {
            if(obj.normalizedNumber.length === field._maxSize){
                if(isNumber(event)){
                    if(element.selectionStart === element.selectionEnd){
                        event.returnValue = false;
                    }
                } else if(!isKeysNavigationOrDelete(event)){
                    event.returnValue = false;
                }
            }
        }
    };*/
    
    /*function isKeysNavigationOrDelete(event){
        return event.keyCode === 8 || event.keyCode === 9 || event.keyCode === 46 || (event.keyCode > 36 && event.keyCode < 41) || event.keyCode === 9;
    }*/
    
    /**
     * Mensagem de confirmação para apagar o registro selecinado da widget.
     * Se o segundo parâmetro for enviado, os campos no array serão exibidos 
     * na mensagem.
     *
     * @param {Widget} widget Widget com o registro selecionado.
     * @param {Array} fieldsToShow Campos na row para serem exibidos na mensagem.
     * @returns {ZHPromise}
     */
    /*this.deleteCrudListingFields = function (widget, fieldsToShow) {
		var deferred = ZHPromise.defer();
		var message = ScreenService.i18n('Delete Register?') + '<br>';
        var row = widget.currentRow;
		
		if (Array.isArray(fieldsToShow)) {
            message += fieldsToShow.reduce((message, fieldName, j)  => {
                if (row[fieldName]) {
                    return message + row[fieldName] + (j != fieldsToShow.length -1 ? ' - ' : '');
                } else {
                    return message + '';
                }
                
            }, '');
        }
		
		ScreenService.confirmMessage(message, 'question', function (success) {
			widget.removeRow().then(function () {
				widget.activate();
				deferred.resolve();
			}, function (error) {
				if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
					ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
				} else {
					ScreenService.showMessage(error.data.error);
				}
				deferred.reject();
			});
		});
		return deferred.promise;
	};*/
	
	/*this.retornaDsParametrosPorTipoDeFaturamento = function(cdfilial){
	    var deferred = ZHPromise.defer();
	    var filter = [
	        {
	            name: "CDFILIAL",
	            operator: "=",
	            value: cdfilial
	        },
	        {
	            name: "NRORG",
	            operator: "=",
	            value: getLocalVar('NRORG')
	        }
        ];
	    restEngine.post('fai#/crud/paramfilial', {"requestType": "FilterData", "filter": filter}).then(function(callback){
	        var parametros = {};
	        if(callback && callback.dataset && callback.dataset.paramfilial && callback.dataset.paramfilial.length){ 
    	        var CDTIPOFATUR = callback.dataset.paramfilial[0].CDTIPOFATUR;
    	        var DSPARAMFATFI = callback.dataset.paramfilial[0].DSPARAMFATFI;
    	        switch (CDTIPOFATUR) {
    	            case '001': // Gestão Direta
    	                parametros.MinEfeConsid = DSPARAMFATFI.substr(0,1);
                        parametros.MinEfeCorrig = DSPARAMFATFI.substr(1,1);
                        parametros.PercAdiantam = DSPARAMFATFI.substr(3,5);
                        parametros.TpNDebAdiant = DSPARAMFATFI.substr(9,2);
                        parametros.LanDebAdiant = DSPARAMFATFI.substr(11,3);
                        parametros.TipDocAdiant = DSPARAMFATFI.substr(8,1);
                        parametros.UtilAdiantam = DSPARAMFATFI.substr(2,1);
                        parametros.UtilEfetPlan = DSPARAMFATFI.substr(14,1);
                        parametros.VrDesDotacao = DSPARAMFATFI.substr(55,1);
                        parametros.CdAjustPadr  = DSPARAMFATFI.substr(56,2);
                        parametros.CdEnCredito  = DSPARAMFATFI.substr(58,2);
                        parametros.CdEncDebito  = DSPARAMFATFI.substr(60,2);
    	                break;
    	            case '003': 
    	                // to-do
    	                break;
                    case '004': // Refeições e Serviços
    	                parametros.MinEfeConsid = DSPARAMFATFI.substr(0,1);
                        parametros.MinEfeCorrig = DSPARAMFATFI.substr(1,1);
                        parametros.PercAdiantam = DSPARAMFATFI.substr(3,5);
                        parametros.TpNDebAdiant = DSPARAMFATFI.substr(9,2);
                        parametros.LanDebAdiant = DSPARAMFATFI.substr(11,3);
                        parametros.TipDocAdiant = DSPARAMFATFI.substr(8,1);
                        parametros.UtilAdiantam = DSPARAMFATFI.substr(2,1);
                        parametros.UtilEfetPlan = DSPARAMFATFI.substr(14,1);
                        parametros.EmprAtacEmis = DSPARAMFATFI.substr(38,2);
                        parametros.EmprOperEmis = DSPARAMFATFI.substr(40,2);
                        parametros.PercServ     = DSPARAMFATFI.substr(49,5);
    	                break;
                    case '007': // Produtos e Serviços
    	                parametros.MinEfeConsid = DSPARAMFATFI.substr(15,1);
                        parametros.MinEfeCorrig = DSPARAMFATFI.substr(16,1);
                        parametros.UtilEfetPlan = DSPARAMFATFI.substr(29,1);
                        parametros.PeComprReven = DSPARAMFATFI.substr(30,6);
                        parametros.RecuImpostos = DSPARAMFATFI.substr(36,1);
                        parametros.EmprAtacEmis = DSPARAMFATFI.substr(38,2);
                        parametros.EmprOperEmis = DSPARAMFATFI.substr(40,2);
                        parametros.CdAjustPadr  = DSPARAMFATFI.substr(56,2);
                        parametros.CdEnCredito  = DSPARAMFATFI.substr(58,2);
                        parametros.CdEncDebito  = DSPARAMFATFI.substr(60,2);
    	                break;
    	        }
	        }
	        deferred.resolve(parametros);
	    });
        return deferred.promise;
	};*/
	 /*
        Handles filter for floating control report
        USAGE:
            Widget with floating control report:
                event: BeforeGenerateReport => call function setFilterReport
            Event or function after initial filter screen => call function newFilterReport
        DEFAULT (PRE SET) STRUCT IN WIDGET STRIPE (PREFERENCE)
            "floatingControlConfig":{
                "dataset": [],
                "ignoreFieldsStripe": false,
                "rangeFields": []
            }
    */

   /*function setDefaultValuesConfig(stripeWidget){
        if(!stripeWidget || stripeWidget == 'DEFAULT'){
            stripeWidget = templateManager.container.widgets.filter( widget => 
                widget.template && widget.template.toLowerCase().indexOf('stripe') > -1
            )[0];
        } else {
            stripeWidget = typeof stripeWidget === 'string' ? templateManager.container.getWidget(stripeWidget) : stripeWidget;
        }
        stripeWidget.floatingControlConfig = stripeWidget.floatingControlConfig || {};
        stripeWidget.floatingControlConfig.dataset = stripeWidget.floatingControlConfig.dataset || [];
        stripeWidget.floatingControlConfig.rangeFields = stripeWidget.floatingControlConfig.rangeFields || [];
        stripeWidget.floatingControlConfig.ignoreFieldsStripe = stripeWidget.floatingControlConfig.hasOwnProperty('ignoreFieldsStripe') ? stripeWidget.floatingControlConfig.ignoreFieldsStripe : false;
        return stripeWidget;
    }*/

    /*this.setFilterReport = function(args, stripeWidget){
        stripeWidget = setDefaultValuesConfig(stripeWidget);
        args.e.metadata.filter = stripeWidget.floatingControlConfig.dataset;
    };*/

    /*function treatLabel(label){
        return ScreenService.i18n(label).split(':').join('');  
    }*/
    /*
        Inserir essa funÃ§Ã£o apos aplicar o filtro, seja no FilterAfterApply ou em um OnChange caso seja uma 
        field que filtra a tela ao inves de um popup de filtro
        
        @params
        stripeWidget => nome da widget de stripe ou o objecto em si
        row (opcional) => row contendo os dados que vÃ£o para o filtro do relatorio
        fieldsToUse (opcional) => array com nome de fields a serem exibidas no filtro do relatorio
        ['NMFILIAL']
        default:
            ele exibe todas as fields visiveis do stripe no filtro do relatorio
        Issue:
            stripeWidget por default procurar por uma widget com template widget/stripe.html
    */
    /*this.newFilterReport = function(stripeWidget, row, fieldsToUse){
        stripeWidget = setDefaultValuesConfig(stripeWidget);
        let config = stripeWidget.floatingControlConfig;
        let dataSet = [];
        row = row || stripeWidget.currentRow;
        let arrayKeysRangeFields = Object.keys(config.rangeFields);
        let allFieldsRange = arrayKeysRangeFields.join('_');
        if(Array.isArray(config.rangeFields) && config.rangeFields.length){
            arrayKeysRangeFields.forEach( rangeField => {
                let dataSets = {
                    $I: {
                        propertyToGet: 'INDEX',
                        value: config.rangeFields[rangeField].itemsToReplace,
                    },
                    $V: {
                        propertyToGet: 'NAMEFIELD',
                        value: row
                    }
                }; 
                let fieldsRange = rangeField.split('_');
                let treatStr = config.rangeFields[rangeField].format.replace(/\$[A-Z]+\d+/g, function(currentMatch){
                    let cKey = currentMatch.match(/(\$[A-Za-z]+)/g)[0];
                    let arrayValues = dataSets[cKey];
                    let index = currentMatch.replace(cKey, '');
                    let currentItem =  arrayValues.propertyToGet == 'INDEX' ? arrayValues.value[index] : arrayValues.value[fieldsRange[index]];
                    return ScreenService.i18n(currentItem);
                });
                dataSet.push(
                    {
                        label: treatLabel(config.rangeFields[rangeField].label),
                        value: treatStr
                    }
                );
            });
        }
        if(Array.isArray(fieldsToUse) && fieldsToUse.length){
            fieldsToUse.forEach( fieldName => {
                let rangeContainsCurrentField = new RegExp(`(?<!([A-Z]+))(${fieldName})(?!([A-Z]+))`, 'gm').test(allFieldsRange);
                if(!rangeContainsCurrentField){
                    let field = stripeWidget.getField(fieldName);
                    dataSet.push(
                        {
                            label: treatLabel(field.label),
                            value: row[field.name]
                        }
                    );
                }
            });
        } 
        if(!config.ignoreFieldsStripe){
            stripeWidget.fields.forEach( field => {
                if(field.isVisible){
                    dataSet.push(
                        {
                            label: treatLabel(field.label),
                            value: row[field.name]
                        }
                    );
                }
            });
        }
        config.dataset = dataSet; 
    };*/
    
    /*this.getReportFormats = function(){
        return reportFormats;  
      };*/
};

Configuration(function (ContextRegister) {
    ContextRegister.register('FAIUtilities', FAIUtilities);
});

// FILE: ./assets/js/utilities/GeralCP_Utility.js
var GeralCP_Utility = function (General, ZhFilterPreferences, ZHPromise) {
    
    this.openFilter = function(widget){

        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
          //  this.setFilter(widget);
        }.bind(this)); 
    };
    
    this.openFilterFilial = function(widget) {
        this.setFieldsGerais(widget);
        var rowsToSet = {};
        this.getFilialLogada().then(function(success) {
            rowsToSet.CDFILIAL = success.dataset.filial[0].CDFILIAL;
            rowsToSet.NMFILIAL = success.dataset.filial[0].NMFILIAL;
            ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
        });
    };
	
	this.getFilialLogada = function() {
        var filter = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                }
		    ];
        return General.callRestEngine('est#/crud/filial', 'FilterData', filter);
    };
    
};

Configuration(function(ContextRegister){
    ContextRegister.register('GeralCP_Utility', GeralCP_Utility);
});

// FILE: ./assets/js/repositories/ger00700_Cliente_Repositories.js
var Ger00700_Cliente_Repositories = function(localStorageEngine, restEngine) {
    self = this;

    self.removePrazoPagamento = function (data) {
        return restEngine.post('cadPed#/crud/prazopgtclie/remove',
            {
                "requestType":"DataSet",
                "dataset": data
            }
        );
    };

    self.inserePrazoPagamento = function (data) {
        return restEngine.post('cadPed#/crud/prazopgtclie/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };

    self.insereParceiro = function(data){
        return restEngine.post('cadPed#/crud/parcnegocio/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };

    self.insereEnderecoParceiro = function(data){
        return restEngine.post('cadPed#/crud/enderecoparc/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };

    self.getParcNegocio = function (inscricao) {
        return restEngine.post('cadPed#/crud/parcnegocio',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "NRINSCRICAOPARC",
                        "operator": "=",
                        "value": inscricao
                    }
                ]
            }
        );
    };

    self.getEnderecoParcNegocio = function (parceiro, tipoEndereco) {
        return restEngine.post('cadPed#/crud/enderecoparc',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "NRPARCNEGOCIO",
                        "operator": "=",
                        "value": parceiro
                    },
                    {
                        "name": "CDTIPOENDERECO",
                        "operator": "=",
                        "value": tipoEndereco
                    }
                ]
            }
        );
    };

    self.getParceria = function(parceria, tipoparceiro){
        return restEngine.post('cadPed#/crud/parceria',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "NRPARCNEGOCIO",
                        "operator": "=",
                        "value": parceria
                    },
                    {
                        "name": "CDTIPOPARCEIRO",
                        "operator": "=",
                        "value": tipoparceiro
                    }
                ]
            }
        );
    };

    self.insereParceria = function(parceria){
        return restEngine.post('cadPed#/crud/parceria/save',
            {
                "requestType": "DataSet",
                "dataset": parceria
            }
        );
    };

    self.getRules = function(groupIds) {
        return restEngine.post('/zhu_acl_element_login',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "GROUP_ID",
                        "operator": "=",
                        "value": groupIds
                    }
                ]
            }
        );
    };

    //getBancoPref
    self.getBancoPref = function (cliente, organizacao) {
        return restEngine.post('cadPed#/crud/bancopref_bancopreferencial',
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": cliente
                    },
                    {
                        "name": "NRORG",
                        "operator": "=",
                        "value": organizacao
                    },
                    {
                        "name": "IDPRIORBPREF",
                        "operator": "=",
                        "value": "S"
                    }
                ]
            }
        );
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger00700_Cliente_Repositories', Ger00700_Cliente_Repositories);
});

// FILE: ./assets/js/services/ger00700_Cliente_Service.js
var Ger00700_Cliente_Service = function(localStorageEngine, ZHPromise, templateManager, ScreenService,Ger00700_Cliente_Repositories) {

    self = this;

    self.removePrazoPagamento = function(data) {
        return Ger00700_Cliente_Repositories.removePrazoPagamento(data);
    };

    self.inserePrazoPagamento = function(data){
        return Ger00700_Cliente_Repositories.inserePrazoPagamento(data);
    };

    self.insereParceiro = function(data){
        return Ger00700_Cliente_Repositories.insereParceiro(data);
    };

    self.insereEnderecoParceiro = function(endereco){
        return Ger00700_Cliente_Repositories.insereEnderecoParceiro(endereco);
    };

    self.getParcNegocio = function(inscricao){
        return Ger00700_Cliente_Repositories.getParcNegocio(inscricao);
    };

    self.getEnderecoParcNegocio = function(parceiro, tipoEndereco){
        return Ger00700_Cliente_Repositories.getEnderecoParcNegocio(parceiro, tipoEndereco);
    };

    self.validaDiasPrazo = function(dataSet){
        var dias = [];
        dataSet.forEach(function(row){
            dias.push(row.NRDIASPGTOCL);
        });
        for(var i in dias){
            if(dias.indexOf(dias[i])!==dias.lastIndexOf(dias[i]) && dias[i]!==undefined && Number.isNaN(dias[i]))
                return false;
        }
        return true;
    };

    self.getParceria = function(parceria, tipoparceiro){
        return Ger00700_Cliente_Repositories.getParceria(parceria, tipoparceiro);
    };

    self.insereParceria = function(parceria){
        return Ger00700_Cliente_Repositories.insereParceria(parceria);
    };

    self.validaPercentual = function(dataSet){
        var percent = 0.0;
        dataSet.forEach(function(row){
            percent +=parseFloat(row.VRPERCPGTOCL);
        });
        return percent ===100;
    };

    self.getBancoPref = function(cliente, organizacao){
        return Ger00700_Cliente_Repositories.getBancoPref(cliente, organizacao);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Ger00700_Cliente_Service", Ger00700_Cliente_Service);
});

// FILE: ./assets/js/services/ped00900_ramo_Service.js
var ped00900_ramo_Service = function(restEngine) {
    
    //chamada do backend para pegar o parametro referente à mascara
    this.getParamAtivCli = function () {
        return restEngine.post('cadPed#/paramativcli',
            {
                "requestType": "FilterData",
                "filter": []
            }
        );
    };
    
    //chamada do backend para inserir novo ramo
    this.insereRamoAtividade = function (data) {
        return restEngine.post('cadPed#/ramo_atividade/save',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };
    
    this.deleteRamoAtividade = function(data){
        return restEngine.post('cadPed#/ramo_atividade/delete',
            {
                "requestType": "DataSet",
                "dataset": data
            }
        );
    };
    
    this.buscaNovoCodigo = function(cdativ, nivelMax) {
        return restEngine.request('cadPed#/geraCodigoRamo', {
            "requestType": "Row",
            "row": {
                "CDATIVCLI": cdativ,
                "ISMAXNIVEL": nivelMax
            }
        }).then(function(callback) {
            return callback.dataset.CODIGO[0];
        });
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("ped00900_ramo_Service", ped00900_ramo_Service);
});

// FILE: ./assets/js/controllers/Fai00700_ClientesPorFilial_Controller.js
var Fai00700_ClientesPorFilial_Controller = function(ScreenService, General, FAIUtilities) {
    /*global Configuration, angular, getLocalVar*/
    var self = this;
    var floatingInlineEdit = { "refreshAction": false, "pdfAction": false, "xlsAction": false, "csvAction": false, customizationAction: { "view": false, "layout": false, "filter": false }, "actions": [] };
    var defaultFloatingControl = { "refreshAction": true, "pdfAction": true, "xlsAction": true, "csvAction": false, customizationAction: { "view": true, "layout": true, "filter": true } };


    this.save = function(widget) {
        var wid = widget.container.getWidget('widgetMain');
        if (wid.isValid()) {
            General.setFloatAttrOnCurrentRow(widget.currentRow, 'VRPERATDESP');

            General.setFloatAttrOnCurrentRow(widget.currentRow, 'NRDIAAVISOCVEN');
            if (wid.currentRow.VRPERATDESP == "") {
                wid.currentRow.VRPERATDESP = 0;
            }
            if (wid.currentRow.IDCLIENPRIN == "S") {
                var data = wid.dataSource.data;
                data.forEach(function(row) {
                    if (row.IDCLIENPRIN == 'S' && row != wid.currentRow) {
                        row.IDCLIENPRIN = 'N';
                    }
                });
            }
            wid.currentRow.CDFILIAL = wid.currentRow.CDFILIAL.includes('@') ? getLocalVar('CDFILIAL') : wid.currentRow.CDFILIAL;
            General.saveCrud(widget).then(function(){
                ScreenService.notificationMessage('Salvo com sucesso!','success');
            });
        }
    };

    this.enableAction = function(widget){
        widget.getAction('addservico').isVisible = true;
    };
    
    this.openFilter = function(widget){
        var row = {
            'CDFILIAL': getLocalVar('CDFILIAL'),
            'NMFILIAL': getLocalVar('CDFILIAL') + ' | ' + getLocalVar('NMFILIAL')
        };
        FAIUtilities.startFilter(widget.container.getWidget('widgetMain'), row);
    };

    this.add = function(widget) {
        var wid = widget.container.getWidget('widgetMain');
        wid.getField('NMFILIAL').showOnForm = true;
        wid.currentRow.NMFILIAL = wid.appliedFilter.FILTER_ROW.NMFILIAL;
        wid.currentRow.CDFILIAL = wid.appliedFilter.FILTER_ROW.CDFILIAL;
    };

    this.edit = function(widget) {
        General.justInteger('#CDEXCLIENFIL');
        var wid = widget.container.getWidget('widgetMain');
        var valorFilial = wid.appliedFilter.FILTER_ROW.NMFILIAL;
        wid.getField('NMFILIAL').showOnForm = false;
        wid.getField('NMFILIAL').showOnView = false;
        wid.currentRow.NMFILIAL = valorFilial;
        wid.backupRow = angular.copy(wid.currentRow);
        widget.edit();
    };

    this.saveInlineEdit = function(widget) {
        widget.dataSource.data.forEach(function(row) {
            if (row.changed == true) {
               if(row.VRPERATDESP_inline != undefined){
                    General.setFloatAttrOnCurrentRow(row, 'VRPERATDESP_inline');
                    General.setFloatAttrOnCurrentRow(row, 'VRPERATDESP');
               }
               if(row.NRDIAAVISOCVEN_inline != undefined){
                    row.NRDIAAVISOCVEN_inline = parseFloat(row.NRDIAAVISOCVEN_inline);
                    row.NRDIAAVISOCVEN = parseFloat(row.NRDIAAVISOCVEN);
               }
            }
        });
        widget.dataSource.save().then(function() {
            ScreenService.notificationMessage("Alteração realizada com sucesso!", "success");
            widget.commitInlineEdit();
            widget.list();
            self.customizationFloating(widget, 1);
            widget.reload();
        }, function(error) {
            ScreenService.showMessage(error.data.error);
        });
    };
    
    this.cancelaEdicaoInline = function(widget) {
        self.customizationFloating(widget, 1);
        widget.reload();
        widget.list();
        widget.editing = false;

    };
    this.verificaCampo = function(row){
        if(row.VRPERATDESP_inline != undefined){
            if(row.VRPERATDESP_inline == ""){
                row.VRPERATDESP_inline = 0;
            }else if(parseFloat(row.VRPERATDESP_inline.replace('.','').replace(',', '.')) > 100){
                row.VRPERATDESP_inline = row.VRPERATDESP;
                ScreenService.showMessage("Valor de rateio deve ser entre 0 e 100.","error");
            }
        }
    };

    this.customizationFloating = function(widget, properties) {
        if(!widget.inViewMode() && !widget.inEditMode()){
            if(properties == 1){
                Object.keys(defaultFloatingControl).forEach(function(prop) {
                widget.floatingControl[prop] = defaultFloatingControl[prop];
            });
            }else{
                Object.keys(floatingInlineEdit).forEach(function(prop) {
                widget.container.getActiveWidget().floatingControl[prop] = floatingInlineEdit[prop];
            });
            }
        }
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Fai00700_ClientesPorFilial_Controller', Fai00700_ClientesPorFilial_Controller);
});

// FILE: ./assets/js/controllers/ger00700_Cliente_Controller.js
var Ger00700_Cliente_Controller = function(ScreenService, templateManager, Endereco, Ger00700_Cliente_Service, ZhFilterPreferences, General, ZHPromise, metaDataFactory, MessageService) {

    var self = this;

    this.numRowFormPgto = 0;

    this.startFiltering = function(widget) {
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises);
    };

    self.salvarBancoPreferencial = function(widget) {
        var existe = false;
        var cliente = widget.getParent().currentRow.CDCLIENTE;
        var organizacao = widget.getParent().currentRow.NRORG;
        if (widget.currentRow.IDPRIORBPREF == "S") {
            Ger00700_Cliente_Service.getBancoPref(cliente, organizacao).then(function(response) {
                var bancoPrioridade = response.dataset.bancopref_bancopreferencial[0];
                if (bancoPrioridade) {
                    if (widget.__is_new) {
                        ScreenService.showMessage("Apenas um banco preferencial pode ser prioritário.");
                    }
                    else {
                        if (bancoPrioridade.CDREDUCONT == widget.currentRow.CDREDUCONT) {
                            General.saveCrud(widget);
                        }
                        else {
                            ScreenService.showMessage("Apenas um banco preferencial pode ser prioritário.");
                        }
                    }
                }
                else {
                    General.saveCrud(widget);
                }
            });
        }
        else {
            General.saveCrud(widget);
        }
    };

    self.checkIDTPENDECLIE = function() {
        var widget = templateManager.container.getWidget("endereco");
        var atual = widget.currentRow.IDTPENDECLIE;
        var data = [];
        var i = 0;

        widget.getField('IDTPENDECLIESELECT').dataSource.rawdata.forEach(function(fieldrow) {
            fieldrow.ENABLE = true;
            widget.dataSource.data.forEach(function(row) {
                if (row.IDTPENDECLIE == fieldrow.IDTPENDECLIE) {
                    if (row.IDTPENDECLIE.localeCompare(atual) === 0 && widget.mode == 'edit') {
                        fieldrow.ENABLE = true;
                    }
                    else {
                        if (widget.currentRow.__is_new && widget.dataSource.data.length > 6) {
                            ScreenService.closeSwipe();
                            ScreenService.showMessage("Limite de endereços excedido.");
                        }
                        else
                            fieldrow.ENABLE = false;
                    }
                }
            });
            if (fieldrow.ENABLE) data[i++] = fieldrow;
        });

        widget.getField('IDTPENDECLIESELECT').dataSource.data = (widget.currentRow.__is_new) ? data : widget.getField('IDTPENDECLIESELECT').dataSource.rawdata;
        widget.currentRow.IDTPENDECLIE = (widget.currentRow.__is_new) ? (data[0] ? data[0].IDTPENDECLIE : null) : widget.currentRow.IDTPENDECLIE;
        widget.currentRow.IDTPENDECLIESELECT = widget.currentRow.IDTPENDECLIE;
        widget.getField('IDTPENDECLIESELECT').reload();
    };

    self.endeclieSetIDTPENDECLIE = function() {
        var widget = templateManager.container.getWidget("endereco");

        widget.currentRow.IDTPENDECLIE = widget.currentRow.IDTPENDECLIESELECT;
    };

    self.endeclieCheckActions = function() {
        var widget = templateManager.container.getWidget("endereco");
        if (widget.currentRow.__is_new) return;

        if (widget.currentRow.IDTPENDECLIE == 'P') widget.getAction('DELETE').isVisible = false;
        else widget.getAction('DELETE').isVisible = true;

        if (widget.dataSource.data.length == widget.getField('IDTPENDECLIESELECT').dataSource.rawdata.length) widget.getAction('ADD').isVisible = false;
        else widget.getAction('ADD').isVisible = true;
    };

    self.checkInscricao = function(widget) {
        var inscricao = General.inscricaoFormat(widget.currentRow.NRINSJURCLIE);

        if (inscricao.valid) {
            widget.currentRow.NRINSJURCLIE = inscricao.value;
            widget.currentRow.IDTPIJURCLIE = inscricao.tipo.cod;
            self.checkInscricaoParceiro(widget);
        }
        else {
            if (inscricao.tipo.cod == 'J') inscricao.tipo.msg = 'CNPJ' + " \"" + inscricao.value + "\" inválido!";
            else if (inscricao.tipo.cod == 'F') inscricao.tipo.msg = 'CPF' + " \"" + inscricao.value + "\" inválido!";
            else if (inscricao.tipo.cod == 'I') inscricao.tipo.msg = inscricao.tipo.desc + " \"" + inscricao.value + "\" inválida!";

            if (inscricao.tipo.msg) ScreenService.showMessage(inscricao.tipo.msg, "warning");
            widget.currentRow.NRINSJURCLIE = null;
        }
    };

    self.addCliente = function() {
        var clienteWidget = templateManager.container.getWidget("cliente");
        var addressWidget = templateManager.container.getWidget("endprinc");
        self.habilitaEnderecoPrincipal();

        clienteWidget.newRow();

        clienteWidget.currentRow.IDTPIJURCLIE = 'J';

        self.checkInscricao(clienteWidget);

        addressWidget.showAsTab = true;
        addressWidget.isVisible = true;

        addressWidget.setCurrentRow({});
        addressWidget.edit();

        addressWidget.currentRow.__is_new = true;
        addressWidget.currentRow.IDTPENDECLIE = "P";
    };

    self.criaCdcliente = function(widget) {
        if (widget.currentRow.__is_new) {
            if (widget.currentRow.NRINSJURCLIE) {
                var inscricao = widget.currentRow.NRINSJURCLIE.replace(/\.|\/|\-/g, '');
                var tipoInscricao = widget.currentRow.IDTPIJURCLIE;
                widget.getField('CDCLIENTE').setValue(tipoInscricao + inscricao);
            }
            else
                widget.getField('CDCLIENTE').setValue('');
        }
    };

    self.setInscricaoJuridica = function(widget) {
        widget.fields.filter(function(field) {
            if (field.id == '115003') {
                field.isVisible = 'true';
                field.showOnForm = 'true';
            }
        });
    };

    self.salvarCliente = function(widget) {

        var clienteWidget = templateManager.container.getWidget('cliente');
        if (clienteWidget.isValid()) {
            var parceiroNegocio = clienteWidget.currentRow.NRPARCNEGOCIO;
            var inscricao = clienteWidget.currentRow.NRINSJURCLIE.replace(/\.|\/|\-/g, '');
            var novaParceria = '';
            clienteWidget.currentRow.NRINSJURCLIE = inscricao;
            if (clienteWidget.currentRow.__is_new) {
                var addressWidget = templateManager.container.getWidget("endprinc");
                addressWidget.dataSourceFilter[0].value = clienteWidget.currentRow.CDCLIENTE;
                if (clienteWidget.isValid() && addressWidget.isValid() && addressWidget.currentRow.CDPAIS) {
                    if (parceiroNegocio) {
                        Ger00700_Cliente_Service.getParceria(parceiroNegocio, 'CLIENTE').then(function(promisse) {
                            var parceria = promisse.dataset.parceria[0];
                            if (!parceria) {
                                clienteWidget.currentRow.NRPARCNEGOCIO = parceiroNegocio;
                                novaParceria = self.geraParceria(clienteWidget);
                                if (novaParceria) {
                                    Ger00700_Cliente_Service.insereParceria(novaParceria).then(function() {
                                        General.saveCrud(clienteWidget).then(function() {
                                            addressWidget.currentRow.CDCLIENTE = clienteWidget.currentRow.CDCLIENTE;
                                            self.salvarEndereco(addressWidget);
                                        });
                                    });
                                }
                            }
                            else {
                                General.saveCrud(clienteWidget).then(function() {
                                    addressWidget.currentRow.CDCLIENTE = clienteWidget.currentRow.CDCLIENTE;
                                    self.salvarEndereco(addressWidget);
                                });
                            }
                        });

                    }
                    else {
                        var parceiro = self.validaParceiro(clienteWidget);
                        Ger00700_Cliente_Service.insereParceiro(parceiro).then(function(data) {
                            clienteWidget.currentRow.NRPARCNEGOCIO = data.dataset.columnsToReturn[0].NRPARCNEGOCIO;
                            novaParceria = self.geraParceria(clienteWidget);
                            Ger00700_Cliente_Service.insereParceria(novaParceria);
                            General.saveCrud(clienteWidget).then(function() {
                                addressWidget.currentRow.CDCLIENTE = clienteWidget.currentRow.CDCLIENTE;
                                self.salvarEndereco(addressWidget);
                            });
                        });
                    }
                    self.habilitaEnderecoGeral();
                }
                else {
                    self.validaCamposRequiredSave(clienteWidget, addressWidget);
                }
            }
            else {
                self.masterDetailSave(clienteWidget);
            }
        }
        else {
            clienteWidget.currentWidget = clienteWidget;
            clienteWidget.activate();
        }

    };

    self.habilitaEnderecoGeral = function() {
        templateManager.container.getWidget("endereco").isVisible = true;
        templateManager.container.getWidget("endprinc").isVisible = false;
        templateManager.container.getWidget("endprinc").showAsTab = false;
        self.changeWidgetAcessibility([templateManager.container.getWidget("endereco"),
            templateManager.container.getWidget("parametrizacao"),
            templateManager.container.getWidget("pagamento"),
            templateManager.container.getWidget("banco"),
            templateManager.container.getWidget("observacao"),
            templateManager.container.getWidget("interlocutores")
        ], true);
    };

    self.habilitaEnderecoPrincipal = function() {
        templateManager.container.getWidget("endereco").isVisible = false;
        templateManager.container.getWidget("endprinc").isVisible = true;
        templateManager.container.getWidget("endprinc").showAsTab = true;
        self.changeWidgetAcessibility([templateManager.container.getWidget("endereco"),
            templateManager.container.getWidget("parametrizacao"),
            templateManager.container.getWidget("pagamento"),
            templateManager.container.getWidget("banco"),
            templateManager.container.getWidget("observacao"),
            templateManager.container.getWidget("interlocutores")
        ], false);
    };

    self.clienteCancelForm = function(widget) {
        var clienteWidget = templateManager.container.getWidget("cliente");
        if (clienteWidget.currentRow.__is_new) {
            var addressWidget = templateManager.container.getWidget("endprinc");

            /*clienteWidget.getField("CDINSCESTA").readOnly = true;
            clienteWidget.getField("CDINSCMUNI").readOnly = true;
            clienteWidget.getField("DSSERIE").readOnly = true;

            addressWidget.getField("NMESTADO").readOnly = true;
            addressWidget.getField("NMMUNICIPIO").readOnly = true;*/

            templateManager.container.getWidget("endereco").isVisible = true;
            templateManager.container.getWidget("endprinc").isVisible = false;

            self.changeWidgetAcessibility([templateManager.container.getWidget("endereco"),
                templateManager.container.getWidget("parametrizacao"),
                templateManager.container.getWidget("pagamento"),
                templateManager.container.getWidget("banco"),
                templateManager.container.getWidget("observacao"),
                templateManager.container.getWidget("interlocutores")
            ], true);

            var indexOfCurrentRow = addressWidget.dataSource.data.indexOf(addressWidget.currentRow);
            if (indexOfCurrentRow !== -1) addressWidget.dataSource.data.pop();
            addressWidget.currentRow = {};

            indexOfCurrentRow = clienteWidget.dataSource.data.indexOf(clienteWidget.currentRow);
            if (indexOfCurrentRow !== -1) clienteWidget.dataSource.data.pop();
            clienteWidget.currentRow = {};

            addressWidget.showAsTab = false;
            addressWidget.isVisible = false;

            clienteWidget.list();

            ScreenService.closeSwipe();

            clienteWidget.activate();
        }
        else {
            //self.clienteResetFields(widget);
            self.masterDetailCancelForm(widget);
        }
    };

    self.deletarCliente = function(widget) {
        General.deleteCrud(widget);
    };

    /* self.clienteResetFields = function(widget) {
         if(widget.getField("CDINSCESTA")) widget.getField("CDINSCESTA").readOnly = true;
         if(widget.getField("CDINSCMUNI")) widget.getField("CDINSCMUNI").readOnly = true;
         if(widget.getField("DSSERIE")) widget.getField("DSSERIE").readOnly = true;

         if(widget.getField("NMESTADO")) widget.getField("NMESTADO").readOnly = true;
         if(widget.getField("NMMUNICIPIO")) widget.getField("NMMUNICIPIO").readOnly = true;

         if(widget.currentRow.CDINSCESTA) widget.currentRow.CDINSCESTA = null;
         if(widget.currentRow.CDINSCMUNI) widget.currentRow.CDINSCMUNI = null;
         if(widget.currentRow.CDSERIE) widget.currentRow.CDSERIE = null;
         if(widget.currentRow.DSSERIE) widget.currentRow.DSSERIE = null;

         if(widget.currentRow.SGESTADO) widget.currentRow.SGESTADO = null;
         if(widget.currentRow.NMESTADO) widget.currentRow.NMESTADO = null;
         if(widget.currentRow.CDMUNICIPIO) widget.currentRow.CDMUNICIPIO = null;
         if(widget.currentRow.NMMUNICIPIO) widget.currentRow.NMMUNICIPIO = null;
     };*/

    self.validaCamposRequiredSave = function(clienteWidget, addressWidget) {
        if (!clienteWidget.isValid() && (!addressWidget.isValid() || !addressWidget.currentRow.CDPAIS)) {
            if (addressWidget.isValid() && !addressWidget.currentRow.CDPAIS) {
                addressWidget.activate();

                addressWidget.isValid();

                clienteWidget.currentWidget = clienteWidget;
                clienteWidget.activate();
            }
            else addressWidget.isValid();
            ScreenService.showMessage("Preencha todos os campos obrigatórios das duas telas!");
        }
        else {
            if ((!addressWidget.isValid() || !addressWidget.currentRow.CDPAIS) && !addressWidget.isActive()) {
                addressWidget.activate();
                addressWidget.isValid();
            }
            else if (!clienteWidget.isValid() && !clienteWidget.isActive()) {
                clienteWidget.currentWidget = clienteWidget;
                clienteWidget.activate();
            }
            ScreenService.showMessage("Preencha os campos obrigatórios!");
        }
    };

    self.geraParceria = function(widget) {
        return [{
            "NRPARCNEGOCIO": widget.currentRow.NRPARCNEGOCIO,
            "CDTIPOPARCEIRO": 'CLIENTE',
            "NRORG": getLocalVar('ERP_NRORGTRAB'),
            "NRORGINCLUSAO": getLocalVar('ERP_NRORGTRAB'),
            "CDOPERINCLUSAO": getLocalVar('ERP_CDOPERADOR'),
            "__is_new_code": true,
            "__new_code_pk": "PARCERIA",
            "__table_pk": "NRPARCERIA",
            "__new_code_length": 10,
            "__is_new": true
        }];
    };

    self.checkInscricaoParceiro = function(widget) {
        var inscricao = widget.currentRow.NRINSJURCLIE.replace(/\.|\/|\-/g, '');
        Ger00700_Cliente_Service.getParcNegocio(inscricao).then(function(promisse) {
            var parcnegocio = promisse.dataset.parcnegocio[0];
            if (parcnegocio) {
                ScreenService.confirmMessage('Ja existe um parceiro para este número de inscrição. Deseja carregar dados do parceiro?', 'question', function(success) {
                    widget.currentRow.NMRAZSOCCLIE = parcnegocio.NMPRINCIPALPARC;
                    widget.currentRow.NMFANTCLIE = parcnegocio.NMSECUNDARIPARC;
                    widget.currentRow.NRPARCNEGOCIO = parcnegocio.NRPARCNEGOCIO;
                });
            }
            else {
                widget.currentRow.NRPARCNEGOCIO = false;
            }
        });
    };

    self.salvarEndereco = function(widget) {
        var existeTipoEndereco = false;
        var tipoEnderecoCliente = widget.currentRow.IDTPENDECLIE;
        var tipoEnderecoParceiro = self.getTipoEndereco(tipoEnderecoCliente);
        var parceiro = widget.getParent().currentRow.NRPARCNEGOCIO;
        var nomeLogradouro = widget.currentRow.DSENDECLIE;
        if (widget.currentRow.__is_new) {
            widget.dataSource.data.forEach(function(endereco) {
                if (endereco.IDTPENDECLIE == tipoEnderecoCliente) {
                    existeTipoEndereco = true;
                }
            });
            self.concatenaCamposEndereco(widget.currentRow);
            self.setaCamposEndereço(widget.currentRow);
            if (widget.isValid()) {
                widget.currentRow.changed = true;
                return widget.saveRow().then(function(response) {
                    widget.currentRow.changed = false;
                    ScreenService.showMessage('Inserido com sucesso.');
                    widget.currentRow.__is_new = false;
                    ScreenService.closeSwipe();
                    widget.list();
                    widget.reload();
                    Ger00700_Cliente_Service.getEnderecoParcNegocio(parceiro, tipoEnderecoParceiro).then(function(promisse) {
                        var endereco = promisse.dataset.enderecoparc[0];
                        if (!endereco) {
                            var enderecoParceiro = self.preparaEnderecoParceiro(widget);
                            Ger00700_Cliente_Service.insereEnderecoParceiro(enderecoParceiro);
                        }
                    });
                });
            }
            if (widget.name == 'endprinc') {
                self.habilitaEnderecoGeral();
            }
        }
        else {
            self.concatenaCamposEndereco(widget.currentRow);
            self.setaCamposEndereço(widget.currentRow);
            self.masterDetailSave(widget);
        }
        widget.currentRow.DSENDECLIE = nomeLogradouro;
    };

    self.validaParceiro = function(widget) {
        var tipo = "";
        switch (widget.currentRow.IDTPIJURCLIE) {
            case "J":
                tipo = "CNPJ";
                break;
            case "O":
                tipo = "CODIGO";
                break;
            case "F":
                tipo = "CPF";
                break;
            default:
                tipo = "LIVRE";
        }
        if (widget.currentRow.__is_new) {
            return [{
                "CDTIPOINSCRICAO": tipo,
                "NRINSCRICAOPARC": widget.currentRow.NRINSJURCLIE,
                "NMPRINCIPALPARC": widget.currentRow.NMRAZSOCCLIE,
                "NMSECUNDARIPARC": widget.currentRow.NMFANTCLIE,
                "CDTIPOPARCPRINCIPAL": "CLIENTE",
                "NRORGINCLUSAO": getLocalVar('ERP_NRORGTRAB'),
                "CDOPERINCLUSAO": getLocalVar('ERP_CDOPERADOR'),
                "__is_new_code": true,
                "__new_code_pk": "PARCNEGOCIO",
                "__table_pk": "NRPARCNEGOCIO",
                "__new_code_length": 10,
                "__columns_to_return": [
                    "NRPARCNEGOCIO"
                ],
                "__is_new": true
            }];
        }
        /*else {
                return [{
                "NMPRINCIPALPARC": widget.currentRow.NMRAZSOCCLIE,
                "NMSECUNDARIPARC": widget.currentRow.NMFANTCLIE,
                "NRORGULTATU": getLocalVar('ERP_NRORGTRAB'),
                "CDOPERULTATU": getLocalVar('ERP_CDOPERADOR'),
                "changed": true,
                "__is_new": false
                }];
                }*/
    };

    self.concatenaCamposEndereco = function(endereco) {
        endereco.DSENDECLIE = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO + " " + endereco.DSENDECLIE : endereco.DSENDECLIE;
        endereco.DSENDECLIE = (endereco.NUMERO) ? endereco.DSENDECLIE + ", " + endereco.NUMERO : endereco.DSENDECLIE;
    };
    
    this.setaCamposEndereço = function(endereco){
        if(endereco.DSENDECLIE.indexOf(',') > 0){
            endereco.DSENDECLIESEP = endereco.DSENDECLIE.slice(0,(endereco.DSENDECLIE.indexOf(',')));   
        }else{
            endereco.DSENDECLIESEP = endereco.DSENDECLIE;
        }
        endereco.NRENDECLIESEP = (endereco.NUMERO) ? endereco.NUMERO : null;
    };

    self.getTipoEndereco = function(idtpendeclie) {
        var cdtipoendereco = "";
        var tipoEndereco = ['P', 'C', 'E', 'X', 'T', 'I'];
        var descTipoEndereco = ['PRINCIPAL', 'COBRANCA', 'EXTERIOR', 'EXPORTACAO', 'ENTREGA', 'INSCRICAO ESTADUAL'];
        for (i = 0; i < tipoEndereco.length; i++) {
            if (idtpendeclie == tipoEndereco[i])
                cdtipoendereco = descTipoEndereco[i];
        }
        return cdtipoendereco;
    };

    self.preparaEnderecoParceiro = function(widget) {
        var cdtipoendereco = self.getTipoEndereco(widget.currentRow.IDTPENDECLIE);
        return [{
            "NRPARCNEGOCIO": widget.getParent().currentRow.NRPARCNEGOCIO,
            "NRCEPENDERECO": widget.currentRow.NRCEPCLIE.replace(/\.|\/|\-/g, ''),
            "CDTIPOENDERECO": cdtipoendereco,
            "DSENDERECO": widget.currentRow.DSENDECLIE,
            "CDLOGRADOURO": widget.currentRow.CDLOGRADOURO,
            "NRIMOVELENDERECO": widget.currentRow.NUMERO,
            "DSCOMPLEENDERECO": widget.currentRow.DSCOMPENDCLI,
            "CDPAIS": widget.currentRow.CDPAIS,
            "SGESTADO": widget.currentRow.SGESTADO,
            "CDMUNICIPIO": widget.currentRow.CDMUNICIPIO,
            "CDBAIRRO": widget.currentRow.CDBAIRCLIE,
            "NRORGINCLUSAO": getLocalVar('ERP_NRORGTRAB'),
            "CDOPERINCLUSAO": getLocalVar('ERP_CDOPERADOR'),
            "__is_new_code": true,
            "__new_code_pk": "ENDERECOPARC",
            "__table_pk": "NRENDERECOPARC",
            "__new_code_length": 10,
            "__is_new": true
        }];
    };

    self.validaAction = function(widget) {
        var action = widget.getAction('ADD');
        if (widget.dataSource.data.length === 0) {
            action.label = 'Adicionar';
            action.icon = 'plus';
        }
        else {
            action.label = 'Editar';
            action.icon = 'pencil';
        }
    };

    // self.setGridModoPagamento = function(widget) {
    //     widget.widgets[0].dataSource.data = [];
    // };

    // self.openFormaPgto = function(widgetGrid) {
    //     var pagamento = templateManager.container.getWidget('pagamento');
    //     if (pagamento.getField('NMFORMPGTO').value()) {
    //         var widgetForm = widgetGrid.widgets[0];
    //         var data = widgetGrid.dataSource.data;
    //         data.forEach(function() {
    //             self.createAndAppendFields(widgetForm);
    //         });
    //         if (widgetForm.fields.length === 0) {
    //             self.createAndAppendFields(widgetForm);
    //         }
    //         widgetForm.currentRow = self.montaRow(data, widgetGrid.getParent().currentRow.CDCLIENTE);
    //         ScreenService.openSwipe(widgetForm);

    //         templateManager.container.getWidget('formpagamento').edit();

    //     }
    //     else {
    //         ScreenService.showMessage('Forma de pagamento deve ser informada.');
    //     }
    // };

    // self.closeFormaPgto = function(widget) {
    //     widget.fields = [];
    //     ScreenService.goBack();
    //     self.numRowFormPgto = 0;
    //     templateManager.updateTemplate();
    // };

    self.montaRow = function(dataSet, cdcliente) {
        var row = {};
        for (var i in dataSet) {
            row['VRPERCPGTOCL' + i] = dataSet[i].VRPERCPGTOCL;
            row['NRDIASPGTOCL' + i] = dataSet[i].NRDIASPGTOCL;
        }
        row.CDCLIENTE = cdcliente;
        return row;
    };

    // self.createAndAppendFields = function(widget) {
    //     var widgetFields = widget.fields;
    //     widget.fields = widgetFields.concat(self.getFields(self.numRowFormPgto, widget));
    //     self.numRowFormPgto++;
    //     self.hideDelete(widget);
    // };

    self.getFields = function(index, widget) {
        var fields = [];
        fields.push(self.getFieldDias(index));
        fields.push(self.getFieldPercent(index));
        fields.push(self.getFieldDelete(index));
        for (var i in fields) {
            fields[i] = metaDataFactory.factoryField(fields[i], widget);
        }
        return fields;
    };

    self.getFieldDias = function(index) {
        return {
            name: "NRDIASPGTOCL" + index,
            label: "Número (dias)",
            template: "field/number.html",
            validations: {
                required: true,
                /*maxLength: {
                 length: 3
                 }*/
                range: {
                    min: 0,
                    max: 999
                }
            },
            events: [{
                name: "FieldOnChange",
                code: "Ger00700_Cliente_Controller.validaDiaOnChange(args.owner.field.widget)"
            }],
            defaultValue: '',
            isVisible: true,
            showOnList: true,
            showOnForm: true,
            class: 4
        };
    };

    self.validaDiaOnChange = function(widget) {
        var dataSet = self.montaDataSet(widget.currentRow);
        self.validaDias(dataSet);
    };

    self.getFieldPercent = function(index) {
        return {
            name: "VRPERCPGTOCL" + index,
            label: "Percentual",
            template: "field/text-edit.html",
            isVisible: true,
            showOnList: true,
            showOnForm: true,
            validations: {
                required: true,
                range: {
                    min: 0,
                    max: 100
                }
            },
            "mask": {
                "type": "viewFloat",
                "params": {
                    "showSymbol": false,
                    "precision": 2,
                    "thousands": ".",
                    "decimal": ","
                }
            },
            defaultValue: '',
            class: 4
        };
    };

    self.getFieldDelete = function(index) {
        return {
            name: "BTNDELETE" + index,
            label: "Excluir",
            template: "field/label-with-icon.html",
            isVisible: true,
            icon: "trash",
            showOnList: true,
            showOnForm: true,
            events: [{
                "name": "FieldOnClick",
                "code": "Ger00700_Cliente_Controller.deleteFields(args.owner.field)"
            }],
            class: 4
        };
    };

    self.deleteFields = function(fieldRemove) {
        var widget = fieldRemove.widget;
        var fields = widget.fields;
        var indexDelete = Number.parseInt(fieldRemove.name.replace('BTNDELETE', ''));
        for (var i = 0; i < fields.length; i++) {
            var index = Number.parseInt(fields[i].name.replace(/(BTNDELETE|VRPERCPGTOCL|NRDIASPGTOCL)/g, ''));
            if (index === indexDelete) {
                delete widget.currentRow[fields[i].name];
                if (widget.currentRow.hasOwnProperty('$error'))
                    delete widget.currentRow.$error[fields[i].name];
                fields.splice(i, 1);
                i--;
            }
            else if (index > indexDelete) {
                var nameFieldAntigo = fields[i].name;
                fields[i].name = nameFieldAntigo.replace(index, index - 1);
                widget.currentRow[fields[i].name] = widget.currentRow[nameFieldAntigo];
                delete widget.currentRow[nameFieldAntigo];
            }
        }
        self.numRowFormPgto--;
        self.hideDelete(widget);
    };

    self.hideDelete = function(widget) {
        var field = widget.getField('BTNDELETE0');
        if (field) {
            if (self.numRowFormPgto <= 1) {
                field.isVisible = false;
            }
            else {
                field.isVisible = true;
            }
        }
    };

    self.validaDias = function(dataSet) {
        var validacao = Ger00700_Cliente_Service.validaDiasPrazo(dataSet);
        if (!validacao) {
            ScreenService.showMessage('Não é possivel cadastrar mais de um prazo para o mesmo dia');
        }
        return validacao;
    };

    self.validaPercentual = function(dataSet) {
        var validacao = Ger00700_Cliente_Service.validaPercentual(dataSet);
        if (!validacao) {
            ScreenService.showMessage('Soma dos totais dos percentuais dos prazos deve totalizar 100%');
        }
        return validacao;
    };

    self.saveFormaPgto = function(widget) {
        var dataSet = self.montaDataSet(widget.currentRow);
        if (widget.isValid() && self.validaDias(dataSet) && self.validaPercentual(dataSet)) {
            General.callRestEngine('cadPed#/delete_cliente_formpgto', 'Row', {
                "CDCLIENTE": widget.currentRow.CDCLIENTE
            }).then(function() {
                General.saveCrud(widget.getParent().getParent()).then(function() {
                    Ger00700_Cliente_Service.removePrazoPagamento(widget.getParent().dataSource.data).then(function() {
                        Ger00700_Cliente_Service.inserePrazoPagamento(dataSet).then(function() {
                            self.closeFormaPgto(widget);
                            templateManager.container.getWidget('modopagamento').reload();
                            templateManager.container.getWidget('pagamento').changeMode('form');
                            templateManager.container.getWidget('pagamento').childTemplate = "widget/form.html";

                        });
                    });
                });
            });
        }else{
            throw "Soma dos totais dos percentuais dos prazos deve totalizar 100%";
        }
    };

    self.montaDataSet = function(currentRow) {
        var dataSet = [];
        for (var i = 0; i < self.numRowFormPgto; i++) {
            dataSet[i] = {};
            dataSet[i].CDCLIENTE = currentRow.CDCLIENTE;
            dataSet[i].__is_new = true;
            dataSet[i].VRPERCPGTOCL = currentRow['VRPERCPGTOCL' + i];
            dataSet[i].NRDIASPGTOCL = currentRow['NRDIASPGTOCL' + i];
        }
        return dataSet;
    };

    // self.saveFormaPagamento = function() {
    //     templateManager.updateTemplate();
    //     var formpgto = templateManager.container.getWidget('pagamento');
    //     var opcaoPagamento = formpgto.getField('IDTPFORPGTCL').value();
    //     var prazopgtclie = templateManager.container.getWidget('modopagamento');
    //     var widgetFormPgto = templateManager.container.getWidget('formpagamento');

    //     if (opcaoPagamento == "V") {
    //         if (!self.prazoDiaCorreto(widgetFormPgto)) {
    //             ZHPromise.all(self.setFieldsPgtoFixo(formpgto), self.saveFormaPgto(widgetFormPgto)).then(function() {
    //                 ZHPromise.all(formpgto.reload()).then(function() {
    //                     formpgto.changeMode('form');
    //                     formpgto.childTemplate = "widget/form.html";
    //                     templateManager.updateTemplate();
    //                 });
    //             });
    //         }
    //         else {
    //             ScreenService.showMessage("Prazo (dias) para pagamento não podem ser duplicados.");
    //         }
    //     }
    //     else if (opcaoPagamento == "F") {
    //         self.setFieldsFormaPgto(formpgto);
    //         self.masterDetailSave(formpgto);
    //         Ger00700_Cliente_Service.removePrazoPagamento(prazopgtclie.dataSource.data).then(function() {
    //             prazopgtclie.reload();
    //         });
    //     }
    //     else {
    //         self.setFieldsFormaPgto(formpgto);
    //         self.setFieldsPgtoFixo(formpgto);
    //         self.masterDetailSave(formpgto);
    //         Ger00700_Cliente_Service.removePrazoPagamento(prazopgtclie.dataSource.data).then(function() {
    //             prazopgtclie.reload();
    //         });
    //     }
    // };

    self.prazoDiaCorreto = function(prazo) {
        var valoresDiasPagamento = [];
        var data = Object.keys(prazo.currentRow);
        var registroDuplicado = false;
        for (var i = 0; i < data.length && !registroDuplicado; i++) {
            var diasPagamento = data[i].substr(0, 12);
            if (diasPagamento.localeCompare('NRDIASPGTOCL') === 0) {
                var valordia = prazo.getField(data[i]).value();
                if (parseInt(valoresDiasPagamento.indexOf(valordia)) == -1) {
                    valoresDiasPagamento.push(valordia);
                }
                else {
                    registroDuplicado = true;
                }
            }
        }
        return registroDuplicado;
    };

    self.setFieldsFormaPgto = function(formpgto) {
        formpgto.currentRow.CDFORMPGTO = null;
    };

    // self.setFieldsPgtoFixo = function(cliente) {
    //     cliente.currentRow.NRDIAPGFIXCL = 1;
    //     cliente.currentRow.NRPARCPGTOCL = 1;
    //     cliente.currentRow.IDUTDIAPGTCL = 'E';
    //     templateManager.updateTemplate();
    // };

    self.justInteger = function(campos) {
        campos.forEach(function(campo) {
            General.justInteger(campo);
        });
    };

    self.setFiltroSearchInstrucoes = function(widget) {
        var banco = widget.currentRow.CDBANCO;
        if (banco) {
            widget.getField("NMINSTCOBR1").readOnly = false;
            widget.getField("NMINSTCOBR2").readOnly = false;
            widget.getField("NMINSTCOBR1").dataSourceFilter[0] = {
                "name": "CDBANCO",
                "operator": "=",
                "value": banco
            };
            widget.getField("NMINSTCOBR2").dataSourceFilter[0] = {
                "name": "CDBANCO",
                "operator": "=",
                "value": banco
            };
        }
        else {
            widget.getField("NMINSTCOBR1").readOnly = true;
            widget.getField("NMINSTCOBR2").readOnly = true;
            widget.getField("NMINSTCOBR1").setValue('');
            widget.getField("NMINSTCOBR2").setValue('');
            widget.getField("NMINSTCOBR1").dataSourceFilter = [];
            widget.getField("NMINSTCOBR2").dataSourceFilter = [];
        }
        widget.getField("NMINSTCOBR1").reload();
        widget.getField("NMINSTCOBR2").reload();
    };

    /* self.setFiltroSearchInstrucoes = function (widget){
         widget.getParent().widgets[4].getField('NMINSTCOBR1').dataSourceFilter[0].value = widget.currentRow.CDBANCO;
     };*/

    // self.mascaraPercentual = function(field) {
    //     var pos = field.value().indexOf(",");
    //     var vrpercpgtocl = field.value().replace(",", ".");
    //     if (vrpercpgtocl > 100) {
    //         ScreenService.showMessage("Valor deve ser inferior a 100.");
    //         field.widget.currentRow.VRPERCPGTOCL = field.widget.backupRow.VRPERCPGTOCL;
    //     }
    //     else {
    //         if (pos != -1) {
    //             field.widget.currentRow.VRPERCPGTOCL = vrpercpgtocl;
    //         }
    //     }
    // };

    self.setCurrentRowForm = function(widget) {
         if (widget.dataSource.data.length) {
             widget.currentRow = widget.dataSource.data[0];
         }
    };

    self.reloadEndereco = function(widget) {
        widget.reload();
    };
    
    self.saveInterlocutores = function(widget) {
        General.saveCrud(widget).then(function() {
            if(widget.currentRow.__is_new != true){
                ScreenService.goBack();
                widget.reload();    
            }
        });
    };

    self.setDataSourceFilho = function() {
        var widgetPai = templateManager.container.getWidget('cliente');
        widgetPai.widgets.forEach(
            function(filha) {
                if (filha.name != 'filterPopup') filha.dataSourceFilter[0].value = widgetPai.currentRow.CDCLIENTE;
            }
        );
        templateManager.container.getWidget('modopagamento').dataSourceFilter[0].value = widgetPai.currentRow.CDCLIENTE;
        templateManager.container.getWidget('parametrizacao').reload([], false);
    };

    // self.setFieldsOpcaoPagamento = function(widget) {
    //     widget = templateManager.container.getWidget('pagamento');
    //     switch (widget.currentRow.IDTPFORPGTCL) {
    //         case "V":
    //             ZHPromise.all(self.habilitaGrid(widget.widgets[0]), self.formaPagamento(widget)).then(function() {
    //                 templateManager.updateTemplate();
    //             });
    //             break;
    //         case "F":
    //             ZHPromise.all(self.pagamentoFixo(widget), self.desabilitaGrid(widget.widgets[0])).then(function() {
    //                 templateManager.updateTemplate();
    //             });
    //             break;
    //         default:
    //             ZHPromise.all(
    //                 self.desabilitaGrid(widget.widgets[0]), self.desabilitaFields(widget)).then(function() {
    //                 templateManager.updateTemplate();
    //             });
    //             break;
    //     }
    //     templateManager.container.getWidget('pagamento').changeMode('form');
    //     templateManager.container.getWidget('pagamento').childTemplate = "widget/form.html";
    //     templateManager.updateTemplate();
    //     templateManager.updateTemplate();
    // };

    //Sem forma de pagamento
    self.desabilitaFields = function(widget) {
        templateManager.updateTemplate();
        widget.getField('NRDIAPGFIXCL').isVisible = false;
        widget.getField('NRPARCPGTOCL').isVisible = false;
        widget.getField('IDUTDIAPGTCL').isVisible = false;
        widget.getField('NMFORMPGTO').isVisible = false;
        templateManager.updateTemplate();
    };

    //Pagamento fixo no dia
    self.pagamentoFixo = function(widget) {
        templateManager.updateTemplate();
        widget.getField('NRDIAPGFIXCL').isVisible = true;
        widget.getField('NRPARCPGTOCL').isVisible = true;
        widget.getField('IDUTDIAPGTCL').isVisible = true;
        widget.getField('NMFORMPGTO').isVisible = false;
        templateManager.updateTemplate();
    };

    //Pela forma de pagamento
    self.formaPagamento = function(widget) {
        templateManager.updateTemplate();
        widget.getField('NRDIAPGFIXCL').isVisible = false;
        widget.getField('NRPARCPGTOCL').isVisible = false;
        widget.getField('IDUTDIAPGTCL').isVisible = false;
        widget.getField('NMFORMPGTO').isVisible = true;
        templateManager.updateTemplate();
    };

    self.desabilitaGrid = function(widget) {
        widget.isVisible = false;
        widget.getAction('SAVE').isVisible = true;
        widget.getAction('ADD').isVisible = false;
        templateManager.updateTemplate();
    };

    self.habilitaGrid = function(widget) {
        widget.isVisible = true;
        widget.getAction('SAVE').isVisible = false;
        widget.getAction('ADD').isVisible = true;
        templateManager.updateTemplate();
    };

    self.checkAddress = function(widget) {
        var bairro = null;
        if (widget.name.localeCompare('interlocutores') === 0) {
            bairro = 'NMBAIRINCLIE';
        }
        else {
            bairro = 'NMBAIRCLIE';
        }
        var reload = self.atualizafiltroEndereco(widget, bairro);

        if (reload[0]) {
            widget.currentRow.SGESTADO = null;
            widget.currentRow.NMESTADO = null;

            if (!widget.currentRow.CDPAIS) widget.getField("NMESTADO").readOnly = true;

            widget.getField("NMESTADO").reload();
        }

        if (reload[1]) {
            widget.currentRow.CDMUNICIPIO = null;
            widget.currentRow.NMMUNICIPIO = null;

            if (!widget.currentRow.SGESTADO) widget.getField("NMMUNICIPIO").readOnly = true;

            widget.getField("NMMUNICIPIO").reload();
        }

        if (reload[2]) {
            widget.currentRow.CDBAIRRO = null;
            if (widget.name.localeCompare('interlocutores') === 0) {
                widget.currentRow.NMBAIRINCLIE = null;
            }
            else {
                widget.currentRow.NMBAIRCLIE = null;
            }
            if (!widget.currentRow.CDMUNICIPIO)
                widget.getField(bairro).readOnly = true;

            widget.getField(bairro).reload();
        }
    };
    
    

    self.atualizafiltroEndereco = function(widget, bairro) {
        var reload = [false, false, false];

        if (widget.currentRow.CDPAIS) {
            widget.getField("NMESTADO").readOnly = false;

            if (widget.getField("NMESTADO").dataSourceFilter[0])
                if (widget.getField("NMESTADO").dataSourceFilter[0].value != widget.currentRow.CDPAIS) reload[0] = true;

            widget.getField("NMESTADO").dataSourceFilter[0] = {
                "name": "CDPAIS",
                "operator": "=",
                "value": widget.currentRow.CDPAIS
            };

            if (widget.currentRow.SGESTADO) {
                widget.getField("NMMUNICIPIO").readOnly = false;

                if (widget.getField("NMMUNICIPIO").dataSourceFilter[0])
                    if (widget.getField("NMMUNICIPIO").dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField("NMMUNICIPIO").dataSourceFilter[1].value != widget.currentRow.SGESTADO) reload[1] = true;

                widget.getField("NMMUNICIPIO").dataSourceFilter[0] = {
                    "name": "CDPAIS",
                    "operator": "=",
                    "value": widget.currentRow.CDPAIS
                };
                widget.getField("NMMUNICIPIO").dataSourceFilter[1] = {
                    "name": "SGESTADO",
                    "operator": "=",
                    "value": widget.currentRow.SGESTADO
                };

                if (widget.currentRow.CDMUNICIPIO) {
                    widget.getField(bairro).readOnly = false;

                    /*if (widget.getField(bairro).dataSourceFilter[0])
                        if (widget.getField(bairro).dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField(bairro).dataSourceFilter[1].value != widget.currentRow.SGESTADO || widget.getField(bairro).dataSourceFilter[2].value != widget.currentRow.CDMUNICIPIO) reload[2] = true;

                    widget.getField(bairro).dataSourceFilter[0] = {
                        "name": "CDPAIS",
                        "operator": "=",
                        "value": widget.currentRow.CDPAIS
                    };
                    widget.getField(bairro).dataSourceFilter[1] = {
                        "name": "SGESTADO",
                        "operator": "=",
                        "value": widget.currentRow.SGESTADO
                    };
                    widget.getField(bairro).dataSourceFilter[2] = {
                        "name": "CDMUNICIPIO",
                        "operator": "=",
                        "value": widget.currentRow.CDMUNICIPIO
                    };
                    */
                }
                else reload[2] = true;
            }
            else reload[1] = reload[2] = true;
        }
        else reload[0] = reload[1] = reload[2] = true;

        return reload;
    };

    self.changeWidgetAcessibility = function(widgets, enabled) {
        widgets.forEach(function(widget) {
            widget.enabled = enabled;
        });

        templateManager.updateTemplate();
    };

    self.getFieldById = function(widget, id) {
        return widget.fields.filter(function(field) {
            return field.id == id;
        })[0];
    };

    self.validateCPF = function(CPF) {
        if (CPF === '') return false;

        if (CPF.length != 11)
            return false;

        if (CPF == "00000000000" ||
            CPF == "11111111111" ||
            CPF == "22222222222" ||
            CPF == "33333333333" ||
            CPF == "44444444444" ||
            CPF == "55555555555" ||
            CPF == "66666666666" ||
            CPF == "77777777777" ||
            CPF == "88888888888" ||
            CPF == "99999999999") return false;

        var soma;
        var resto;
        soma = 0;

        for (i = 1; i <= 9; i++) soma = soma + parseInt(CPF.substring(i - 1, i)) * (11 - i);
        resto = (soma * 10) % 11;

        if ((resto == 10) || (resto == 11)) resto = 0;
        if (resto != parseInt(CPF.substring(9, 10))) return false;

        soma = 0;
        for (i = 1; i <= 10; i++) soma = soma + parseInt(CPF.substring(i - 1, i)) * (12 - i);
        resto = (soma * 10) % 11;

        if ((resto == 10) || (resto == 11)) resto = 0;
        if (resto != parseInt(CPF.substring(10, 11))) return false;
        return true;
    };

    self.validateCNPJ = function(CNPJ) {
        if (CNPJ === '') return false;

        if (CNPJ.length != 14)
            return false;

        if (CNPJ == "00000000000000" ||
            CNPJ == "11111111111111" ||
            CNPJ == "22222222222222" ||
            CNPJ == "33333333333333" ||
            CNPJ == "44444444444444" ||
            CNPJ == "55555555555555" ||
            CNPJ == "66666666666666" ||
            CNPJ == "77777777777777" ||
            CNPJ == "88888888888888" ||
            CNPJ == "99999999999999")
            return false;

        tamanho = CNPJ.length - 2;
        numeros = CNPJ.substring(0, tamanho);
        digitos = CNPJ.substring(tamanho);
        soma = 0;
        pos = tamanho - 7;
        for (i = tamanho; i >= 1; i--) {
            soma += numeros.charAt(tamanho - i) * pos--;
            if (pos < 2)
                pos = 9;
        }
        resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(0))
            return false;

        tamanho = tamanho + 1;
        numeros = CNPJ.substring(0, tamanho);
        soma = 0;
        pos = tamanho - 7;
        for (i = tamanho; i >= 1; i--) {
            soma += numeros.charAt(tamanho - i) * pos--;
            if (pos < 2)
                pos = 9;
        }
        resultado = soma % 11 < 2 ? 0 : 11 - soma % 11;
        if (resultado != digitos.charAt(1))
            return false;

        return true;
    };

    self.masterDetailCancelForm = function(widget) {

        if (self.formChangeTemplate(widget) && widget.getParent()) {
            var widgets = widget.getParent().widgets;

            self.changeWidgetAcessibility(widgets.concat(widget.getParent()), true);
        }
        else self.changeWidgetAcessibility(widget.widgets, true);

        if (widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if (indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();

            ScreenService.closeSwipe();
        }
        else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
    };

    self.masterDetailEdit = function(widget) {
        //var widget = templateManager.container.getActiveWidget();
        var widgets;

        if (!widget.editing) {
            if (self.formChangeTemplate(widget) && widget.getParent()) {
                widgets = widget.getParent().widgets;

                self.changeWidgetAcessibility(widgets.filter(function(w) {
                    return w.name != widget.name;
                }).concat(widget.getParent()), false);
            }
            else self.changeWidgetAcessibility(widget.widgets, false);

            widget.backupRow = Util.clone(widget.currentRow);
            widget.edit();
        }
    };

    /*
    self.masterDetailGoBackToList = function(widget) {
        // var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe();
        widget.list();
    };
    
    self.masterDetailGoBackToParent = function(widget) {
        // var widget = templateManager.container.getActiveWidget();

        ScreenService.closeSwipe().then(function() {
            widget.getParent().list();
            widget.getParent().activate();
        });
    };
    */

    self.masterDetailNewRow = function(widget) {
        // var widget = templateManager.container.getActiveWidget();

        self.changeWidgetAcessibility(widget.widgets, false);

        widget.newRow();
    };

    self.setCdcliente = function(widget) {
        widget.currentRow.CDCLIENTE = widget.dataSourceFilter[0].value;
    };

    self.validaTipoPrincipal = function(widget) {
        var existe = false;
        widget.dataSource.data.forEach(function(data) {
            if (widget.currentRow.IDPRBASEPRIN == "S" && data.IDPRBASEPRIN == "S" && data.CDPRECOBASE != widget.currentRow.CDPRECOBASE) {
                existe = true;
            }
        });
        return existe;
    };

    self.validaDiaPagamento = function(widget) {
        Ger00700_Cliente_Service.validaDiaPagamento(widget);
    };

    self.masterDetailSave = function(widget) {
        // var widget = templateManager.container.getActiveWidget();
        if (widget.isValid()) {
            widget.currentRow.changed = true;

            if (widget.currentRow.__is_new) {
                widget.currentRow.NRORGINCLUSAO = (widget.currentRow.NRORGINCLUSAO) ? widget.currentRow.NRORGINCLUSAO : getLocalVar('NRORG');
                widget.currentRow.CDOPERINCLUSAO = (widget.currentRow.CDOPERINCLUSAO) ? widget.currentRow.CDOPERINCLUSAO : getLocalVar('CDOPERADOR');
            }
            else {
                widget.currentRow.NRORGULTATU = (widget.currentRow.NRORGULTATU) ? widget.currentRow.NRORGULTATU : getLocalVar('NRORG');
                widget.currentRow.CDOPERULTATU = (widget.currentRow.CDOPERULTATU) ? widget.currentRow.CDOPERULTATU : getLocalVar('CDOPERADOR');
            }
            widget.saveRow().then(function(response) {
                widget.currentRow.changed = false;

                if (self.formChangeTemplate(widget) && widget.getParent()) {
                    widget.view();
                    var widgets = widget.getParent().widgets;
                    self.changeWidgetAcessibility(widgets.concat(widget.getParent()), true);
                }
                else {
                    if (widget.currentRow.__is_new) {
                        ScreenService.closeSwipe();
                        widget.changeMode('form');
                        widget.childTemplate = "widget/form.html";
                    }
                    else {
                        widget.changeMode('form');
                        widget.childTemplate = "widget/form.html";
                    }
                    self.changeWidgetAcessibility(widget.widgets, true);
                }
                if (widget.currentRow.__is_new) {
                    widget.currentRow.__is_new = false;
                }
                else {
                    ScreenService.showMessage('Salvo com sucesso.');
                    widget.view();
                }
            }.bind(self), function(error) {
                var errorMessage = 'Timeout';
                if (error.data) errorMessage = error.data.error;

                ScreenService.showMessage(errorMessage);
            });

        }
        else if (!widget.isValid()) {
            ScreenService.showMessage('É necessário preencher todos os campos obrigatórios.');
            return false;
        }
    };

    self.formChangeTemplate = function(widget) {
        // var widget = templateManager.container.getActiveWidget();
        if ((widget.template != "widget/form.html") && (widget.template != "widget/form-view.html")) return false;

        if (!widget.templateToForm) widget.templateToForm = "widget/form.html";
        if (!widget.templateToView) widget.templateToForm = "widget/form-view.html";

        if (widget.template == widget.templateToForm) widget.template = widget.templateToView;
        else if (widget.template == widget.templateToView) widget.template = widget.templateToForm;

        templateManager.updateTemplate();

        return true;
    };

    self.unMask = function(str) {
        if (typeof str === 'string' && str.indexOf('R$') != -1)
            str = $.currency.unmaskString(str, {
                "thousands": "."
            });
        else if (typeof str === 'string' && str.indexOf('%') != -1)
            str = parseFloat(str.replace(',', '.'));
        else str = str.replace(/[\D]+/g, '');
        return str;
    };

    //---------------------------------------

    self.endeClieValidarCep = function(widget, CEP) {
        if (CEP.length == 10) {
            Endereco.buscarCep(CEP).then(function(response) {
                var endereco = response.dataset.ENDERECO;

                self.setDataSourceEndereco(widget, endereco);
                if (endereco) {
                    widget.currentRow.CDPAIS = (endereco.CDPAIS) ? endereco.CDPAIS : '';
                    widget.currentRow.NMPAIS = (endereco.NMPAIS) ? endereco.NMPAIS : '';
                    widget.currentRow.SGESTADO = (endereco.SGESTADO) ? endereco.SGESTADO : '';

                    widget.currentRow.NMESTADO = (endereco.NMESTADO) ? endereco.NMESTADO : '';
                    /*if(endereco.NMESTADO) {
                        reload[0] = true;
                    }*/

                    widget.currentRow.CDMUNICIPIO = (endereco.CDMUNICIPIO) ? endereco.CDMUNICIPIO : '';
                    widget.currentRow.NMMUNICIPIO = (endereco.NMMUNICIPIO) ? endereco.NMMUNICIPIO : '';
                    /*if(endereco.NMMUNICIPIO) {
                        reload[1] = true;
                    }*/

                    widget.currentRow.CDBAIRCLIE = (endereco.CDBAIRRO) ? endereco.CDBAIRRO : '';
                    widget.currentRow.NMBAIRINCLIE = (endereco.NMBAIRRO.slice(0, 29)) ? endereco.NMBAIRRO.slice(0, 29) : '';
                    widget.currentRow.NMBAIRCLIE = widget.currentRow.NMBAIRINCLIE.slice(0, 29);
                    /*if(endereco.NMBAIRRO) {
                        reload[2] = true;
                    }*/

                    if (widget.name == 'interlocutores') {
                        widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '';
                        widget.currentRow.DSENDEINCLIE = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
                        /*idget.currentRow.DSENDEINCLIE = logradouro + " " + dsendeinclie;
                        widget.currentRow.DSLOGRADOURO = logradouro;*/
                    }
                    else {
                        widget.currentRow.CDLOGRADOURO = (endereco.CDLOGRADOURO) ? endereco.CDLOGRADOURO : '';
                        widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '';
                        widget.currentRow.DSENDECLIE = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
                    }
                }
                else if (!endereco || response.dataset.ERRO) {
                    if (widget.name == 'interlocutores') {
                        widget.currentRow.NRCEPINCLIE = '';
                    }
                    else {
                        widget.currentRow.NRCEPCLIE = '';
                    }
                }

                widget.redraw();
                widget.reload();

                if (response.dataset.ERRO) ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");

                /*if(reload[0]) {
                    if(!widget.currentRow.CDPAIS) widget.getField("NMESTADO").readOnly = true;
                    widget.getField("NMESTADO").reload();
                }

                if(reload[1]) {
                    if(!widget.currentRow.SGESTADO) widget.getField("NMMUNICIPIO").readOnly = true;
                    widget.getField("NMMUNICIPIO").reload();
                }

                if(reload[2]) {
                    var bairro = null;
                    if (widget.name.localeCompare('interlocutores') === 0){
                        bairro = widget.currentRow.NMBAIRINCLIE;
                    }else{
                        bairro = widget.currentRow.NMBAIRCLIE;
                    }
                    if(!widget.currentRow.CDMUNICIPIO) widget.getField(bairro).readOnly = true;

                    var nomeCampoBairro =  (widget.name ==='endprinc' || widget.name === 'endereco') ?'NMBAIRCLIE':'NMBAIRINCLIE';
                    widget.getField(nomeCampoBairro).reload();
                }*/

            }.bind(self), function(error) {

                widget.currentRow.CDPAIS = '';
                widget.currentRow.NMPAIS = '';
                widget.currentRow.SGESTADO = '';
                widget.currentRow.NMESTADO = '';
                widget.currentRow.CDMUNICIPIO = '';
                widget.currentRow.NMMUNICIPIO = '';
                widget.currentRow.NMBAIRCLIE = '';

                var errorMessage = 'Timeout';

                if (error.data) errorMessage = error.data.error;
                else if (error) errorMessage = error;

                ScreenService.showMessage(errorMessage);
            });
        }
    };

    self.setDataSourceEndereco = function(widget, endereco) {
        if (widget.name.localeCompare('interlocutores') === 0) {
            bairro = "NMBAIRINCLIE";
        }
        else {
            bairro = "NMBAIRCLIE";
        }
        widget.getField("NMESTADO").dataSourceFilter[0] = {
            "name": "CDPAIS",
            "operator": "=",
            "value": endereco.CDPAIS
        };
        widget.getField("NMESTADO").readOnly = true;
        widget.getField("NMESTADO").reload();
        widget.getField("NMMUNICIPIO").dataSourceFilter[0] = {
            "name": "CDPAIS",
            "operator": "=",
            "value": endereco.CDPAIS
        };
        widget.getField("NMMUNICIPIO").dataSourceFilter[1] = {
            "name": "SGESTADO",
            "operator": "=",
            "value": endereco.SGESTADO
        };
        widget.getField("NMMUNICIPIO").readOnly = true;
        widget.getField("NMMUNICIPIO").reload();
        /*widget.getField(bairro).dataSourceFilter[0] = {
            "name": "CDPAIS",
            "operator": "=",
            "value": endereco.CDPAIS
        };
        widget.getField(bairro).dataSourceFilter[1] = {
            "name": "SGESTADO",
            "operator": "=",
            "value": endereco.SGESTADO
        };
        widget.getField(bairro).dataSourceFilter[2] = {
            "name": "CDMUNICIPIO",
            "operator": "=",
            "value": endereco.CDMUNICIPIO
        };*/
        widget.getField(bairro).readOnly = false;
        widget.getField(bairro).reload();
    };


    self.validatePessoaJurFis = function(widget) {
        var inscricao = widget.currentRow.NRINSJURCLIE;
        var tipoInscricao = widget.currentRow.IDTPIJURCLIE;
        if (!widget) widget = templateManager.container.getWidget('cliente');

        if (tipoInscricao == 'F' && !self.validateCPF(self.unMask(inscricao)) && inscricao) {
            ScreenService.showMessage('CPF Inválido', 'warning');
            widget.currentRow.NRINSJURCLIE = '';
        }
        else if (tipoInscricao == 'J' && !self.validateCNPJ(self.unMask(inscricao)) && inscricao) {
            ScreenService.showMessage('CNPJ Inválido', 'warning');
            widget.currentRow.NRINSJURCLIE = '';
        }
    };

    this.salvarObservacao = function(widget) {
        if (widget.isValid()) {
            /**
             * Alterado para atender o cliente TecGeo
             *
             * Campo DSOBSERVCLIE (Long Raw) estourando quando atinge 4000 caracteres;
             * 
             * Foi necessário tirar a integração Delphi x Mobile para funcionar;
             * 
             * Basicamente o Mobile lê o que existe no Delphi e converte para HTML
             * uma vez salvo, ambos não integram mais;
             */
            //widget.currentRow.DSOBSERVCLIE_CLOB = widget.currentRow.DSOBSERVCLIE;

            if (widget.currentRow.__is_new)
                widget.currentRow.CDCLIENTE = widget.getParent().currentRow.CDCLIENTE;

            General.callRestEngine('cadPed#/salvarObservacaoCliente', 'Row', widget.currentRow).then(
                function(response) {
                    widget.activate();
                    if (widget.currentRow.__is_new) {
                        widget.list(true);
                        ScreenService.goBack();
                        widget.reload();
                    }
                    else {
                        widget.computeDescriptionOrder();
                        widget.view();
                    }
                },
                function(callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }
            );
        }
    };


//------------------------------------------------------------------------------------------------------------------------

    self.setFieldsOpcaoPagamento = function(widget){
        General.justInteger('#NRDIAPGFIXCL');
        General.justInteger('#NRPARCPGTOCL');
        self.exibicaoFormaPagamento(widget);
    };


    this.setDataSourceFilterPrazos = function () {
        var modopagamento = templateManager.container.getWidget('modopagamento');
        
        modopagamento.dataSourceFilter = [
            {
                "name": "CDCLIENTE",
                "operator": "=",
                "value": templateManager.container.getWidget('cliente').currentRow.CDCLIENTE
            }    
        ];
        
        modopagamento.reload();
    };


    self.masterDetailGoBackToParent = function(widget) {
        ScreenService.closeSwipe().then(function(){
            if(widget == templateManager.container.getWidget('contapagar') || widget == templateManager.container.getWidget('contacorrente') || widget == templateManager.container.getWidget('modopagamento')){
                widget.getParent().getParent().list();
                widget.deactivate();
                widget.getParent().getParent().activate();
                widget.getParent().getParent().reload();
            } else {
                widget.getParent().list();
                widget.deactivate();
                widget.getParent().activate();
                widget.getParent().reload();     
            }
        });
    };

    self.masterDetailGoBackToList = function(widget) {
        ScreenService.closeSwipe();
        widget.list();
    };


    this.editarFormaPgto = function(widget) {
        var prazo = widget.container.getWidget("modopagamento");
        
        enableEditPrazosFormaPgto(prazo);
        
        General.widgetEdit(widget);
    };
    

    this.cancelarFormaPagamento = function(widget) {
        var prazo = widget.container.getWidget("modopagamento");
        
        disableEditPrazosFormaPgto(prazo);
        
        General.widgetCancelForm(widget);
        this.exibicaoFormaPagamento(widget);
    };

    self.saveFormaPagamento = function(){
        var widgetPagamento = templateManager.container.getWidget('pagamento');
        var opcaoPagamento = widgetPagamento.getField('IDTPFORPGTCL').value();
        var widgetPrazos = templateManager.container.getWidget('modopagamento');
        
        if (opcaoPagamento == "V"){
            if(isValidPrazoPagamento(widgetPrazos)) {
                self.setFieldsPgtoFixo(widgetPagamento);
                salvarFormaPagamentoComPrazos(widgetPrazos);
            }
        } else if (opcaoPagamento == "F"){
            self.setFieldsFormaPgto(widgetPagamento);
            self.masterDetailSaveFormaPgto(widgetPagamento);
            Ger00700_Cliente_Service.removePrazoPagamento(widgetPrazos.dataSource.data).then(function (){
                    widgetPrazos.reload();
                }
            );
            widgetPagamento.reload();
        } else {
            self.setFieldsFormaPgto(widgetPagamento);
            self.setFieldsPgtoFixo(widgetPagamento);
            self.masterDetailSaveFormaPgto(widgetPagamento);
            Ger00700_Cliente_Service.removePrazoPagamento(widgetPrazos.dataSource.data).then(function (){
                    widgetPrazos.reload();
                }
            );
            widgetPagamento.reload();
        }
    };


    self.exibicaoFormaPagamento = function(widget) {
        var nomeFormaPagamento = sanitizaNomeFormaPagamento(widget);
        var formaPagamento = widget.currentRow[nomeFormaPagamento];
        
        switch (formaPagamento) {
            default:
                widget.getField('NRDIAPGFIXCL').isVisible   = false;
                widget.getField('NRPARCPGTOCL').isVisible   = false;
                widget.getField('IDUTDIAPGTCL').isVisible   = false;
                widget.getField('NMFORMPGTO').isVisible     = false;
                widget.getField('PRAZOSBUTTON').isVisible   = false;
                widget.getField('NMFORMPGTO').validations   = {};
                widget.getField('NRDIAPGFIXCL').validations = {};
                widget.getField('NRPARCPGTOCL').validations = {};
                break;
            case 'F':
                widget.getField('NRDIAPGFIXCL').isVisible   = true;
                widget.getField('NRPARCPGTOCL').isVisible   = true;
                widget.getField('IDUTDIAPGTCL').isVisible   = true;
                widget.getField('NMFORMPGTO').isVisible     = false;
                widget.getField('PRAZOSBUTTON').isVisible   = false;
                widget.getField('NMFORMPGTO').validations   = {};
                widget.getField('NRDIAPGFIXCL').validations = {required: true};
                widget.getField('NRPARCPGTOCL').validations = {required: true};
                break;
            case 'V':
                widget.getField('NRDIAPGFIXCL').isVisible   = false;
                widget.getField('NRPARCPGTOCL').isVisible   = false;
                widget.getField('IDUTDIAPGTCL').isVisible   = false;
                widget.getField('NMFORMPGTO').isVisible     = true;
                widget.getField('PRAZOSBUTTON').isVisible   = true;
                widget.getField('NMFORMPGTO').validations   = {required: true};
                widget.getField('NRDIAPGFIXCL').validations = {};
                widget.getField('NRPARCPGTOCL').validations = {};
                break;
        }
    };


    this.abrePrazoPercentual = function(widget) {
        var modopagamento = widget.container.getWidget("modopagamento");
        if(widget.isValid() || widget.mode == "view"){
            ScreenService.openPopup(modopagamento);
        }
    };

    this.confirmarPrazo = function(widget) {
            
        var fields = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        var percentualName = fields.percentualName;
        var diasName = fields.diasName;
        var total = 0;
        var prazos = widget.dataSource.data;
        
        prazos.forEach(function(row) {
            var index = prazos.indexOf(row);
            if (row[percentualName] == 0) {
                prazos.splice(index, 1);
            }
        });
        
        for(var i = 0; i < prazos.length; i++) {
            var valor  = parseFloat(prazos[i][percentualName]);
            var nrdia = parseFloat(prazos[i][diasName]); 
            total += valor;
            
            if(nrdia > 999 || nrdia < 0) {
                MessageService.showMessageByCode("prazoDias");
                return false;
            }
            var existe = 0;
            for(var j = 0; j < prazos.length; j++) {
                if(prazos[j][diasName] == nrdia)
                    existe++;
            }
            if(existe > 1) {
                MessageService.showMessageByCode("prazoDiasCadastrados");
                return false;
            }
        }
        
        if(total != 100) {
            MessageService.showMessageByCode("somaDosPercentuaisDosPrazos");
            return false;
        }
        
        widget.list();
        ScreenService.closePopup();
    };


    self.cancelarPrazosPagamento = function(widgetPrazos){
        var actionsToShow = ['ADD', 'SAVE'];
        var fieldsInlineEdit = ['NRDIASPGTOCL', 'VRPERCPGTOCL'];
        var ativarWidget = true;
        var widgetPagamento =  widgetPrazos.container.getWidget('pagamento');
        var nomeWidgetExcecao = widgetPagamento.name;
        
        self.changeWidgetAcessibility(getWidgetsExcetoEscolhida(widgetPrazos, nomeWidgetExcecao), ativarWidget);
        widgetPagamento.editing = !ativarWidget;
        
        widgetPrazos.actions.filter(function(action){actionsToShow.includes(action.name);}).forEach(function(action){ action.isVisible = false;});
        widgetPrazos.fields.filter(function(field){fieldsInlineEdit.includes(field.name);}).forEach(function(field){field.inlineEditable = '';});
        widgetPrazos.showCheckbox = false;
        widgetPrazos.list();
        
        var namefieldsToLock = ['IDTPFORPGTCL', 'NRDIAPGFIXCL', 'NRPARCPGTOCL', 'NMFORMPGTO'];
        
        widgetPagamento.fields.filter(function(field){namefieldsToLock.includes(field.name);}).forEach(function(field){field.readOnly = true;});
        
        widgetPagamento.reload();
        widgetPrazos.dataSourceFilter = widgetPrazos.backupDataSourceFilter;
        widgetPrazos.reload();
    };


    this.voltarPrazo = function(widget) {
        var fields = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        var percentualName = fields.percentualName;
        var diasName = fields.diasName;
        
        widget.dataSource.data = widget.dataSource.data.filter(function(row) {
            return row[percentualName] != 0 && row[diasName] != 0;
        });
        ScreenService.closePopup();
        templateManager.container.getWidget('pagamento').activate();
    };


    this.adicionaPrazo = function(widget, dadosCliente) {
        widget.newRow();
        widget.currentRow.CDCLIENTE  = dadosCliente.currentRow.CDCLIENTE;
    };


    this.excluirPrazo = function(widget) {
        var checkedRows = widget.getCheckedRows();
        checkedRows.forEach(function(row) {
            var index = widget.dataSource.data.indexOf(row);
            widget.dataSource.data.splice(index, 1);
        });
        widget.unSelectAll();
    };


        this.justInt = function(widget) {
        var fields = sanitizaNomeFieldsPercentualAndDiaPrazo(widget);
        var diasName = fields.diasName;
        var diasNameInline = diasName + '_inline';
        
        widget.currentRow[diasName] = parseInt(widget.currentRow[diasName], 10);
        widget.currentRow[diasNameInline] = parseInt(widget.currentRow[diasName], 10);
    };


    function enableEditPrazosFormaPgto(widget) {
        widget.backupData = angular.copy(widget.dataSource.data);
        widget.showCheckbox = true;
        widget.getAction("adicionarPrazo").isVisible = true;
        
        widget.getField("NRDIASPGTOCL").inlineEditable = "number";
        widget.getField("VRPERCPGTOCL").inlineEditable = "number";
    }

    self.setFieldsPgtoFixo = function(cliente){
        cliente.currentRow.NRDIAPGFIXCL = 1;
        cliente.currentRow.NRPARCPGTOCL = 1;
        cliente.currentRow.IDUTDIAPGTCL = 'E';
    };
    
    function sanitizaNomeFieldsPercentualAndDiaPrazo(widgetPrazoPercentual) {
        var fields = {
            percentualName: '',
            diasName: ''
        };
        
        fields.percentualName = 'VRPERCPGTOCL';
        fields.diasName = 'NRDIASPGTOCL';
        
        return fields;
    }
    
    function getWidgetsExcetoEscolhida(widgetExcecao) {
        var widgetCliente = templateManager.container.getWidget('cliente');
        var widgetsExcetoEscolhida = function(widget) {
            return widget.name !== widgetExcecao.name;
        };
        
        return widgetCliente.widgets.filter(widgetsExcetoEscolhida).concat(widgetCliente);
    }
    
    function sanitizaNomeFormaPagamento(widget) {
        return widget.name === 'formaPagamento' ? 'IDTPFORPGTAF' : 'IDTPFORPGTCL';
    }
    
    function isValidPrazoPagamento(widgetPrazos) {
        var prazos = widgetPrazos.dataSource.data;
        var diasJaEncontrados = [];
        var percentuaisJaEncontrados = [];
        var prazoAtual, dias, percentual;
        
        for (var index = 0; index < prazos.length; index++) {
            prazoAtual = prazos[index];
            dias = prazoAtual.NRDIASPGTOCL;
            percentual = parseFloat(prazoAtual.VRPERCPGTOCL);
            
            if (Util.isEmptyOrBlank(dias) && Util.isEmptyOrBlank(percentual)) {
                MessageService.showMessageByCode("prencherCampos");
                return false;
            }
            
            if (!validarDiasPrazoPagamento(dias, diasJaEncontrados)) {
                return false;
            }
            
            if (!validarPercentualPrazoPagamento(percentual, percentuaisJaEncontrados)) {
                return false;
            }
        }
        
        var sum = function(accumulator, currentValue) {
            return parseFloat(accumulator) + parseFloat(currentValue);
        };
        var somaPercentuais = percentuaisJaEncontrados.reduce(sum, 0);
            
        if (somaPercentuais != 100) {
            MessageService.showMessageByCode("somaDosPercentuais", {"PARAM": somaPercentuais},"%");
            return false;
        }
        
        return true;
    }
    
    function validarDiasPrazoPagamento(dias, diasJaEncontrados) {
        var isValid = false;
        
        if (Util.isEmptyOrBlank(dias) || dias == 0) {
            MessageService.showMessageByCode("campoNumeroNaoPodeSerZero");
        } else if (diasJaEncontrados.includes(dias)) {
            MessageService.showMessageByCode("prazoNaoDuplicados");
        } else {
            isValid = true;
            diasJaEncontrados.push(dias);
        }
        
        return isValid;
    }
    
    function validarPercentualPrazoPagamento(percentual, percentuaisJaEncontrados) {
        var isValid = false;
        
        if (!isIntervaloPercentualValido(percentual)) {
            MessageService.showMessageByCode("percentualEntreUmECem");
        } else {
            percentuaisJaEncontrados.push(percentual);
            isValid = true;
        }
        
        return isValid;
    }
    
    function isIntervaloPercentualValido(valorPercentual) {
        return valorPercentual >= 1 && valorPercentual <= 100;
    }
    
    function disableEditPrazosFormaPgto(widget) {
        widget.reload();
        widget.showCheckbox = false;
        widget.getAction("adicionarPrazo").isVisible = false;
        
        delete widget.getField("NRDIASPGTOCL").inlineEditable;
        delete widget.getField("VRPERCPGTOCL").inlineEditable;
    }
    
    function salvarFormaPagamentoComPrazos(widgetPrazos) {

        var widgetFormaPagamento = templateManager.container.getWidget('pagamento');
        
            return General.saveCrud(widgetFormaPagamento).then(function(success) {
                
                widgetPrazos.dataSource.data.forEach(function(dados){
                    dados.NRDIASPGTOCL = parseFloat(dados.NRDIASPGTOCL);
                    dados.VRPERCPGTOCL = parseFloat(dados.VRPERCPGTOCL);
                });
                
                General.callRestEngine('cadPed#/clienteController/salvarPrazos', 'DataSet', widgetPrazos.dataSource.data).then(function(success){
                    processAfterSavePrazos();
                }).catch(function(error) {
                    MessageService.showMessageByCode('ocorreuErro');
                    console.log(error);
                });
            });

    }
    
    function processAfterSavePrazos() {
        var prazos = templateManager.container.getWidget("modopagamento");
        var fmpgto = templateManager.container.getWidget("pagamento");
        
        General.formWidgetSwitchTemplate(fmpgto);
        General.changeWidgetAcessibility(fmpgto.getParent().widgets, true);
        fmpgto.view();
        prazos.showCheckbox = false;
        prazos.getAction("adicionarPrazo").isVisible = false;
        prazos.getField("NRDIASPGTOCL").inlineEditable = "";
        prazos.getField("VRPERCPGTOCL").inlineEditable = "";
        
        prazos.dataSourceFilter = [
            {
                "name": "CDCLIENTE",
                "operator": "=",
                "value": templateManager.container.getWidget('cliente').currentRow.CDCLIENTE
            }    
        ];
        
        prazos.reload();
    }
    
    this.cancelarPrazo = function(widget) {
        widget.reload();
        widget.list();
    };
    
    self.masterDetailSaveFormaPgto = function(widget) {
        
        if(!widget.currentRow.IDCLIPRINCIPAL){
            widget.currentRow.IDCLIPRINCIPAL = 'N';    
        }
        if(!widget.currentRow.IDZERSALDCON){
            widget.currentRow.IDZERSALDCON = 'N';    
        }
        if(!widget.currentRow.IDGERNFCLIE){
            widget.currentRow.IDGERNFCLIE = 'N';    
        }
        if(!widget.currentRow.IDSITFINCLIE){
            widget.currentRow.IDSITFINCLIE = 'N';    
        }
        if(!widget.currentRow.IDLIGEXTCLIE){
            widget.currentRow.IDLIGEXTCLIE = 'N';    
        }
        if(!widget.currentRow.NRLIMATEMES){
            widget.currentRow.NRLIMATEMES = 'N';    
        }
        if(!widget.currentRow.IDTPLIMATEFAT){
            widget.currentRow.IDTPLIMATEFAT = 'N';    
        }
        if(!widget.currentRow.IDPGFRETTRANCLI){
            widget.currentRow.IDPGFRETTRANCLI = 'N';    
        }
        if(!widget.currentRow.IDLIBATDCLIINAD){
            widget.currentRow.IDLIBATDCLIINAD = 'N';    
        }
        if(!widget.currentRow.IDCADVERSAOCLI){
            widget.currentRow.IDCADVERSAOCLI = 'N';    
        }
        if(!widget.currentRow.IDTIPOPORTECLIE){
            widget.currentRow.IDTIPOPORTECLIE = 'N';    
        }
        if(!widget.currentRow.IDCOMPARQXMLCLI){
            widget.currentRow.IDCOMPARQXMLCLI = 'N';    
        }
        if(!widget.currentRow.IDCLISECATCLPRI){
            widget.currentRow.IDCLISECATCLPRI = 'N';    
        }
        if(!widget.currentRow.IDGRAVOBSCLIPED){
            widget.currentRow.IDGRAVOBSCLIPED = 'N';    
        }
        if(!widget.currentRow.IDEXBTPNOMECLIE){
            widget.currentRow.IDEXBTPNOMECLIE = 'N';    
        }
        if(!widget.currentRow.IDUTLALVCLIE){
            widget.currentRow.IDUTLALVCLIE = 'N';    
        }
        if(!widget.currentRow.IDUTDESCICMS){
            widget.currentRow.IDUTDESCICMS = 'N';    
        }    
        if(!widget.currentRow.IDCONSFINAL){
            widget.currentRow.IDCONSFINAL = 'N';    
        }
        if(!widget.currentRow.CDCLIENTE){
            widget.currentRow.CDCLIENTE = 'N';    
        }
        if(!widget.currentRow.IDTPIJURCLIE){
            widget.currentRow.IDTPIJURCLIE = 'N';    
        }
        if(!widget.currentRow.NRINSJURCLIE){
            widget.currentRow.NRINSJURCLIE = 'N';    
        }
        if(!widget.currentRow.NMRAZSOCCLIE){
            widget.currentRow.NMRAZSOCCLIE = 'N';    
        }        
        if(!widget.currentRow.NMFANTCLIE){
            widget.currentRow.NMFANTCLIE = 'N';    
        }         
        if(!widget.currentRow.IDENDEMISCLI){
            widget.currentRow.IDENDEMISCLI = 'N';    
        }        
        if(!widget.currentRow.IDENDCFOPCLI){
            widget.currentRow.IDENDCFOPCLI = 'N';    
        }        
        if(!widget.currentRow.IDPRIPUBCLIE){
            widget.currentRow.IDPRIPUBCLIE = 'N';    
        }   
        if(!widget.currentRow.IDVERSALDCLI){
            widget.currentRow.IDVERSALDCLI = 'N';    
        }   
        if(!widget.currentRow.IDUTSALDCLI){
            widget.currentRow.IDUTSALDCLI = 'N';    
        }   
        if(!widget.currentRow.IDCALCDVCLIE){
            widget.currentRow.IDCALCDVCLIE = 'N';    
        }   
        if(!widget.currentRow.IDUTSUBCLIEN){
            widget.currentRow.IDUTSUBCLIEN = 'N';    
        }   
        if(!widget.currentRow.VRPEDESCFORN) {
                widget.currentRow.VRPEDESCFORN = 0;
        }
        
        if(widget.isValid()) {
            widget.currentRow.changed = true;

            if(widget.currentRow.__is_new) {
                widget.currentRow.NRORGINCLUSAO = (widget.currentRow.NRORGINCLUSAO)? widget.currentRow.NRORGINCLUSAO : getLocalVar('NRORG');
                widget.currentRow.CDOPERINCLUSAO = (widget.currentRow.CDOPERINCLUSAO)? widget.currentRow.CDOPERINCLUSAO : getLocalVar('CDOPERADOR');
            } else {
                widget.currentRow.NRORGULTATU = (widget.currentRow.NRORGULTATU)? widget.currentRow.NRORGULTATU : getLocalVar('NRORG');
                widget.currentRow.CDOPERULTATU = (widget.currentRow.CDOPERULTATU)? widget.currentRow.CDOPERULTATU : getLocalVar('CDOPERADOR');
            }

            widget.saveRow().then(function(response){
                widget.currentRow.changed = false;
                
                if((widget.currentRow.IDTPFORPGTCL == null) || (widget.currentRow.IDTPFORPGTCL == 'F')){
                    General.callRestEngine('cadPed#/clienteController/deletarPrazos', 'Row', widget.currentRow);    
                }
                
                if(widget == templateManager.container.getWidget('endereco') || widget == templateManager.container.getWidget('endprinc')){
                    if(widget.currentRow.IDCOMPARQXMLCLI != null && widget.currentRow.IDCOMPARQXMLCLI != ""){
                        General.callRestEngine('cadPed#/clienteController/salvarCompacArq', 'Row', widget.currentRow).then(function(success) {
                            widget.getParent().currentRow.IDCOMPARQXMLCLI = widget.currentRow.IDCOMPARQXMLCLI;
                        });
                    }
                }
                
                if(self.formChangeTemplate(widget) && widget.getParent()) {
                    
                    widget.list();
                    
                    var widgets = widget.getParent().widgets;
                    self.changeWidgetAcessibility(widgets.concat(widget.getParent()), true);
                } else {
                    if(widget.currentRow.__is_new) {
                        ScreenService.closeSwipe();
                        widget.list();
                    } else {
                        widget.list();
                    }
                    
                    if(widget == templateManager.container.getWidget('interlocutores')){
                        widget.view();
                        ScreenService.closeSwipe();
                        widget.list();
                    }

                    self.changeWidgetAcessibility(widget.widgets, true);
                }

                if(widget.currentRow.__is_new) {
                    widget.currentRow.__is_new = false;
                } else{
                    widget.reload();
                }
                if(widget == templateManager.container.getWidget('endereco')){
                    widget.view();
                    widget.reload();
                }
            }.bind(self), function(error) {
                var errorMessage = 'Timeout';
                
                if(widget == templateManager.container.getWidget('interlocutores')){
                    ScreenService.closeSwipe();
                    templateManager.container.getWidget('interlocutores').reload();
                }

                if (error.data) errorMessage = error.data.error;

                MessageService.showMessageByCode({"PARAM":errorMessage});
                widget.getParent().list();
            });     
        } else {
            if(widget == templateManager.container.getWidget('parametrizacao')){
                if(widget.getField('NMTPBAIXAPAG').value() == "" || widget.getField('VRPEDESCFORN').value() == null){
                    widget.fieldGroups[1].opened = true;
                }  
            }
            
            return false;
        }
    };
    
    self.getLevelByMaskContabil = function(widget){
        var filtro = General.getLevelByMask('CDPICTCCTB',1).length;
        
        widget.getField("NMCONTCTBL").dataSourceFilter[0] = {
            "name": "CDNVCONTCTBL",
            "operator": "=",
            "value": filtro
        };
        
        widget.getField('NMCONTCTBL').reload();
    };
    
    this.ConsultaCnpj = function(){
        var widget = templateManager.container.getWidget('cliente');
        var widgetEndereco = templateManager.container.getWidget('endprinc');
        
        var codigo = widget.getField('NRINSJURCLIE');
        var tipoInscricao = widget.getField('IDTPIJURCLIE');
        if(codigo.value() != null){
            if(tipoInscricao.value() == 'J'){
                try{
                    General.callRestEngine('cadPed#/ConsultaCNPJ', 'Row', widget.currentRow).then(function(success) {
                        var data = success.dataset.data[0];
                        var endereco = data.PessoaJuridicaNFeResult.Enderecos;
                        if(data.PessoaJuridicaNFeResult.Transacao.Status == true){
                            widget.getField("NMRAZSOCCLIE").setValue(data.PessoaJuridicaNFeResult.RazaoSocial);
                            widget.getField("NMFANTCLIE").setValue(data.PessoaJuridicaNFeResult.NomeFantasia);
                            if(data.CDMUNICIPIO && data.SGESTADO){
                                    widgetEndereco.currentRow.CDPAIS = '0055';
                                    widgetEndereco.currentRow.NMPAIS = 'Brasil';
                                    widgetEndereco.currentRow.SGESTADO = data.SGESTADO;
                                    widgetEndereco.currentRow.NMESTADO = endereco.Estado;
                                    widgetEndereco.currentRow.CDMUNICIPIO = data.CDMUNICIPIO;
                                    widgetEndereco.currentRow.NMMUNICIPIO = endereco.Cidade;
                                    widgetEndereco.currentRow.NMBAIRCLIE = endereco.Bairro;    
                            }
                            widgetEndereco.currentRow.NRCEPCLIE = endereco.CEP;
                            widgetEndereco.currentRow.NUMERO = endereco.Numero;
                            widgetEndereco.currentRow.DSCOMPENDCLI = endereco.Complemento;
                            widgetEndereco.currentRow.DSENDECLIE = endereco.Logradouro;
                            widgetEndereco.reload();    
                        }else{
                            ScreenService.showMessage(data.PessoaJuridicaNFeResult.Transacao.CodigoStatusDescricao);
                        }
                        
                    });    
                }catch(erro){
                    ScreenService.showMessage("Ocorreu um erro ao tentar fazer a consulta.");
                }        
            }else{
                ScreenService.showMessage('Para fazer a consulta é necessário informar um CNPJ.');    
            }
        }else{
            ScreenService.showMessage('Para fazer a consulta é nescessário informar o código.');
        }
    };
    
    this.readOnlyConsSituCad = function (widget){
        if(widget.currentRow.__is_new){
            widget.getField('NRINSJURCLIE').class = '5';
            widget.getField('IDTPIJURCLIE').class = '5'; 
            widget.getField('btnConsSituCad').isVisible = true;
            widget.redraw();
        }
        else{
            widget.getField('btnConsSituCad').isVisible = false;
            widget.getField('NRINSJURCLIE').class = '8';
            widget.getField('IDTPIJURCLIE').class = '3';    
        }
            
    };
    
    this.resetaCamposCliente = function(){
        var widget = templateManager.container.getWidget('cliente');
        var widgetEndereco = templateManager.container.getWidget('endprinc');
        
        widgetEndereco.currentRow.CDPAIS = '';
        widgetEndereco.currentRow.NMPAIS = '';
        widgetEndereco.currentRow.SGESTADO = '';
        widgetEndereco.currentRow.NMESTADO = '';
        widgetEndereco.currentRow.CDMUNICIPIO = '';
        widgetEndereco.currentRow.NMMUNICIPIO = '';
        widgetEndereco.currentRow.NMBAIRCLIE = '';    
        widgetEndereco.currentRow.NRCEPCLIE = '';
        widgetEndereco.currentRow.NUMERO = '';
        widgetEndereco.currentRow.DSCOMPENDCLI = '';
        widgetEndereco.currentRow.DSENDECLIE = '';
        widgetEndereco.currentRow.NMCONTCLIE = '';
        widgetEndereco.currentRow.NRTELECLIE = '';
        widgetEndereco.currentRow.NRRAMALCLIE = '';
        widgetEndereco.currentRow.NRTELECLIE1 = '';
        widgetEndereco.currentRow.NRRAMALCLIE1 = '';
        widgetEndereco.currentRow.NRFAXCLIE = '';
        widgetEndereco.currentRow.NRTELRESICLI = '';
        widgetEndereco.currentRow.NRCELULARCLI = '';
        widgetEndereco.currentRow.DSEMAILCLIE = '';
        widgetEndereco.currentRow.DSEMAILCLIENFE = '';
        widgetEndereco.reload();
        widget.getField("NMRAZSOCCLIE").setValue('');
        widget.getField("NMCOMPRZSCLI").setValue('');
        widget.getField("NMFANTCLIE").setValue('');
        widget.getField("NRINSESTCLIE").setValue('');
        widget.getField("NRINSMUNICLIE").setValue('');
        widget.getField("CDEXCLIENTE").setValue('');
        widget.getField("CDIDCLIENTE").setValue('');
        widget.getField("IDCLIEATIV").setValue('');
        widget.getField("NRINSCSUFRAMACL").setValue('');
        widget.getField("DTCADACLIE").clearValue(widget.getField("DTCADACLIE"));
        widget.getField("DTNASCCLIE").clearValue(widget.getField("DTNASCCLIE"));

    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger00700_Cliente_Controller', Ger00700_Cliente_Controller);
});


// FILE: ./assets/js/controllers/ped00600_Vendedor_Controller.js
var Ped00600_Vendedor_Controller = function (ScreenService, restEngine, General, Endereco, templateManager, ZHPromise, ZhFilterPreferences) {

	var self = this;

	self.startFiltering = function (widget) {
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises);
    };

	self.setDataSourceFilter = function (widget) {
		if (!widget.currentRow){
			widget.currentRow = {};
		}
		widget.currentRow.CDVENDEDOR = widget.getParent().currentRow.CDVENDEDOR;
		widget.dataSourceFilter = [
			{
				name: "CDVENDEDOR",
				operator: "=",
				value: widget.getParent().currentRow.CDVENDEDOR
            }
        ];
		widget.reload();
	};

	self.setMaxLangth = function (widget) {
		if (widget.currentRow.IDTPIJURVEN === "F") {
			widget.getField("NRINSJURVEN").maxlength = 11;
		} else {
			widget.getField("NRINSJURVEN").maxlength = 14;
		}
		widget.getField("NRINSJURVEN").value('');
	};

	self.CarregaEndereco = function (args) {
		if (args.owner.dataSource.data[0] === undefined) {
			args.owner.currentRow = {
				CDVENDEDOR: args.owner.getParent().currentRow.CDVENDEDOR
			};
			args.owner.currentRow.__is_new = true;
		} else {
			args.owner.currentRow = args.owner.dataSource.data[0];
		}
	};

	self.validaPorcentagem = function (widget, campo) {
		var currentRow = widget.currentRow;
		switch (campo) {
		case 1:
			if (currentRow.VRPEMAXDESVE && (currentRow.VRPEMAXDESVE <= 0 || currentRow.VRPEMAXDESVE > 100)) {
				ScreenService.showMessage('Operação bloqueada. O valor tem que está entre 0,01% e 100%');
				currentRow.VRPEMAXDESVE = "";
			}
			break;

		case 2:
			if (currentRow.VRPECOMVEN && (currentRow.VRPECOMVEN <= 0 || currentRow.VRPECOMVEN >= 100)) {
				ScreenService.showMessage('Operação bloqueada. O valor tem que está entre 0,01% e 99,99%');
				currentRow.VRPECOMVEN = "";
			}
			break;

		case 3:
			if (currentRow.VRCOMPROVEND && (currentRow.VRCOMPROVEND <= 0 || currentRow.VRCOMPROVEND >= 100)) {
				ScreenService.showMessage('Operação bloqueada. O valor tem que está entre 0,01% e 99,99%');
				currentRow.VRCOMPROVEND = "";
			}
			break;
		}
	};

	self.validaEmail = function (widget) {
		var currentRow = widget.currentRow;
		var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
		if (!re.test(currentRow.DSEMAILVEN)) {
			ScreenService.showMessage('Email Invalido');
			currentRow.DSEMAILVEN = "";
		}
	};
	
	self.editar = function (widget) {
		widget.edit();
		widget.template = "widget/form.html";
		templateManager.updateTemplate();
		
		var widgetsToDeactivate = widget.parent.widgets;
	
		General.changeWidgetAcessibility(
			widgetsToDeactivate.filter(function (subwidget) {
				return subwidget.name != widget.name;
			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		false);
	
		if (!widget.currentRow.__is_new) {
			widget.getField('NMESTADO').readOnly = false;
			widget.getField('NMMUNICIPIO').readOnly = false;
			widget.getField('NMBAIRVEN').readOnly = false;
		} else {
			widget.getField('NMESTADO').readOnly = true;
			widget.getField('NMMUNICIPIO').readOnly = true;
			widget.getField('NMBAIRVEN').readOnly = true;
		}
	};

	self.cancelar = function (widget) {
		widget.template = widget.templateToView;
		
		var widgetsToDeactivate = widget.parent.widgets;

		General.changeWidgetAcessibility(
			widgetsToDeactivate.filter(function (subwidget) {
				return subwidget.name != widget.name;
			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		true);
		
		widget.view();
	};

	self.salvar = function (widget) {
		if (widget.isValid()) {
			widget.currentRow.NRCEPVEN = self.removeInscricaoMask(widget.currentRow.NRCEPVEN);

			if (widget.currentRow.NRCELULARVEN)
				widget.currentRow.NRCELULARVEN = self.removeInscricaoMask(widget.currentRow.NRCELULARVEN);

			if (widget.currentRow.NRTELRESIVEN)
				widget.currentRow.NRTELRESIVEN = self.removeInscricaoMask(widget.currentRow.NRTELRESIVEN);

			if (widget.currentRow.NRFAXVEN)
				widget.currentRow.NRFAXVEN = self.removeInscricaoMask(widget.currentRow.NRFAXVEN);

			if (widget.currentRow.NRTELEVEN)
				widget.currentRow.NRTELEVEN = self.removeInscricaoMask(widget.currentRow.NRTELEVEN);

			General.saveCrud(widget);
			widget.template = widget.templateToView;
			
			var widgetsToDeactivate = widget.parent.widgets;

		General.changeWidgetAcessibility(
			widgetsToDeactivate.filter(function (subwidget) {
				return subwidget.name != widget.name;
			}).concat(widget.parent), //retorna um array com a widget parent e suas widgets filhas, exceto aquela que será editada
		true);
			
			widget.view();
		}
	};

	self.salvarNovoVendedor = function (widget) {
		if(widget.isValid()){
			
			// Valida Comissão e Comissão Promocional
			if(widget.currentRow.CDCOMISSAO && widget.currentRow.CDCOMISSAOPROMO){
				if(widget.currentRow.CDCOMISSAO == widget.currentRow.CDCOMISSAOPROMO){
					ScreenService.showMessage('Operação bloqueada. Comissão deve ser diferente da Comissão (Promocional).');
					return;
				}
			}
			
			// Valida Operador Cadastrado
			self.validaOperador(widget).then(function () {
				// Formata Inscrição Juríduca Vendedor
				widget.currentRow.NRINSJURVEN = self.removeInscricaoMask(widget.currentRow.NRINSJURVEN);
				
				General.saveCrud(widget);
			});
			

		}
	};
	
	self.validaOperador = function (widget) {
		var deferred = ZHPromise.defer();
		
		// Valida Operador Cadastrado
		if(widget.currentRow.CDOPERADOR){
			var filter = [
                {
                    "name": "CDOPERADOR",
                    "operator": "=",
                    "value": widget.currentRow.CDOPERADOR
                },
                {
                    "name": "CDVENDEDOR",
                    "operator": "<>",
                    "value": widget.currentRow.CDVENDEDOR
                }
            ];

            General.callRestEngine('cadPed#/crud/vendedor', 'FilterData', filter).then(function (result) {
                result = result.dataset.vendedor;
                if(result.length > 0){
					ScreenService.showMessage('Operação bloqueada. Operador já cadastrado para outro Vendedor.');
					deferred.reject();
                }else deferred.resolve();
            });
		}else deferred.resolve();
		
		return deferred.promise;
	};

	self.removeInscricaoMask = function (inscricao) {

		if (!Util.isEmptyOrBlank(inscricao)){
			return inscricao.replace(/[^0-9]/g, "");
		}

	};

	self.setIDTPENDEVEN = function (widget) {
		widget.currentRow.IDTPENDEVEN = "P";
	};

	self.endeVendValidarCep = function (widget, CEP) {
		if (CEP.length == 10) {
			Endereco.buscarCep(CEP).then(function (response) {
				var endereco = response.dataset.ENDERECO;
				self.setDataSourceEndereco(widget, endereco);
				if (endereco) {
					widget.currentRow.CDPAIS = (endereco.CDPAIS) ? endereco.CDPAIS : '';
					widget.currentRow.NMPAIS = (endereco.NMPAIS) ? endereco.NMPAIS : '';
					widget.currentRow.SGESTADO = (endereco.SGESTADO) ? endereco.SGESTADO : '';
					widget.currentRow.NMESTADO = (endereco.NMESTADO) ? endereco.NMESTADO : '';
					widget.currentRow.CDMUNICIPIO = (endereco.CDMUNICIPIO) ? endereco.CDMUNICIPIO : '';
					widget.currentRow.NMMUNICIPIO = (endereco.NMMUNICIPIO) ? endereco.NMMUNICIPIO : '';
					widget.currentRow.CDBAIRRO = (endereco.CDBAIRRO) ? endereco.CDBAIRRO : '';
					widget.currentRow.NMBAIRVEN = (endereco.NMBAIRRO) ? endereco.NMBAIRRO : '';
					// widget.currentRow.NMBAIRCLIE = widget.currentRow.NMBAIRINCLIE;
					var logradouro;
					var dsendeinclie;
					if (widget.name == 'interlocutores') {
						logradouro = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '';
						dsendeinclie = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
						widget.currentRow.DSENDEINCLIE = logradouro + " " + dsendeinclie;
					} else {
						widget.currentRow.CDLOGRADOURO = (endereco.CDLOGRADOURO) ? endereco.CDLOGRADOURO : '';
						widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '';
						widget.currentRow.DSENDECLIE = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
					}
					if (widget.name === 'ped00600_vendedor_endereco'){
						logradouro = (endereco.DSLOGRADOURO) ? endereco.DSLOGRADOURO : '';
						dsendeinclie = (endereco.DSENDERECO) ? endereco.DSENDERECO : '';
						widget.currentRow.DSENDEVEN = logradouro + " " + dsendeinclie;
					}
				} else if (!endereco || response.dataset.ERRO) {
					if (widget.name == 'interlocutores') {
						widget.currentRow.NRCEPINCLIE = '';
					} else {
						widget.currentRow.NRCEPCLIE = '';
					}
				}

				if (response.dataset.ERRO){ 
					ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
				}

			}.bind(this)).catch(function(error){
				ScreenService.showMessage('CEP inválido');
				widget.currentRow.NRCEPVEN = "";
				widget.currentRow.DSENDEVEN = "";
				widget.currentRow.CDPAIS = "";
				widget.currentRow.NMPAIS = "";
				widget.currentRow.SGESTADO = "";
				widget.currentRow.NMESTADO = "";
				widget.currentRow.CDMUNICIPIO = "";
				widget.currentRow.NMMUNICIPIO = "";
				widget.currentRow.CDBAIRRO = "";
				widget.currentRow.NMBAIRVEN = "";
				widget.getField('NMESTADO').readOnly = true;
				widget.getField('NMMUNICIPIO').readOnly = true;
				widget.getField('NMBAIRVEN').readOnly = true;
			});
		}
	};

	self.setDataSourceEndereco = function (widget, endereco) {
		if (widget.name.localeCompare('interlocutores') === 0) {
			bairro = "NMBAIRINVEN";
		} else {
			bairro = "NMBAIRVEN";
		}
		widget.getField("NMESTADO").dataSourceFilter[0] = {
			"name": "CDPAIS",
			"operator": "=",
			"value": endereco.CDPAIS
		};
		widget.getField("NMESTADO").readOnly = false;
		widget.getField("NMESTADO").reload();
		widget.getField("NMMUNICIPIO").dataSourceFilter[0] = {
			"name": "CDPAIS",
			"operator": "=",
			"value": endereco.CDPAIS
		};
		widget.getField("NMMUNICIPIO").dataSourceFilter[1] = {
			"name": "SGESTADO",
			"operator": "=",
			"value": endereco.SGESTADO
		};
		widget.getField("NMMUNICIPIO").readOnly = false;
		widget.getField("NMMUNICIPIO").reload();
		widget.getField(bairro).dataSourceFilter[0] = {
			"name": "CDPAIS",
			"operator": "=",
			"value": endereco.CDPAIS
		};
		widget.getField(bairro).dataSourceFilter[1] = {
			"name": "SGESTADO",
			"operator": "=",
			"value": endereco.SGESTADO
		};
		widget.getField(bairro).dataSourceFilter[2] = {
			"name": "CDMUNICIPIO",
			"operator": "=",
			"value": endereco.CDMUNICIPIO
		};
		widget.getField(bairro).readOnly = false;
		widget.getField(bairro).reload();
	};

	self.checkAddress = function (widget) {
		var bairro = null;
		if (widget.name.localeCompare('interlocutores') === 0) {
			bairro = 'NMBAIRVEN';
		} else {
			bairro = 'NMBAIRVEN';
		}
		var reload = self.atualizafiltroEndereco(widget, bairro);

		if (reload[0]) {
			widget.currentRow.SGESTADO = null;
			widget.currentRow.NMESTADO = null;

			if (!widget.currentRow.CDPAIS) widget.getField("NMESTADO").readOnly = true;

			widget.getField("NMESTADO").reload();
		}

		if (reload[1]) {
			widget.currentRow.CDMUNICIPIO = null;
			widget.currentRow.NMMUNICIPIO = null;

			if (!widget.currentRow.SGESTADO) widget.getField("NMMUNICIPIO").readOnly = true;

			widget.getField("NMMUNICIPIO").reload();
		}

		if (reload[2]) {
			widget.currentRow.CDBAIRRO = null;
			if (widget.name.localeCompare('interlocutores') === 0) {
				widget.currentRow.NMBAIRVEN = null;
			} else {
				widget.currentRow.NMBAIRVEN = null;
			}
			if (!widget.currentRow.CDMUNICIPIO)
				widget.getField(bairro).readOnly = true;

			widget.getField(bairro).reload();
		}
	};

	self.atualizafiltroEndereco = function (widget, bairro) {
		var reload = [false, false, false];

		if (widget.currentRow.CDPAIS) {
			widget.getField("NMESTADO").readOnly = false;

			if (widget.getField("NMESTADO").dataSourceFilter[0])
				if (widget.getField("NMESTADO").dataSourceFilter[0].value != widget.currentRow.CDPAIS) reload[0] = true;

			widget.getField("NMESTADO").dataSourceFilter[0] = {
				"name": "CDPAIS",
				"operator": "=",
				"value": widget.currentRow.CDPAIS
			};

			if (widget.currentRow.SGESTADO) {
				widget.getField("NMMUNICIPIO").readOnly = false;

				if (widget.getField("NMMUNICIPIO").dataSourceFilter[0])
					if (widget.getField("NMMUNICIPIO").dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField("NMMUNICIPIO").dataSourceFilter[1].value != widget.currentRow.SGESTADO) reload[1] = true;

				widget.getField("NMMUNICIPIO").dataSourceFilter[0] = {
					"name": "CDPAIS",
					"operator": "=",
					"value": widget.currentRow.CDPAIS
				};
				widget.getField("NMMUNICIPIO").dataSourceFilter[1] = {
					"name": "SGESTADO",
					"operator": "=",
					"value": widget.currentRow.SGESTADO
				};

				if (widget.currentRow.CDMUNICIPIO) {
					widget.getField(bairro).readOnly = false;

					if (widget.getField(bairro).dataSourceFilter[0])
						if (widget.getField(bairro).dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField(bairro).dataSourceFilter[1].value != widget.currentRow.SGESTADO || widget.getField(bairro).dataSourceFilter[2].value != widget.currentRow.CDMUNICIPIO) reload[2] = true;

					widget.getField(bairro).dataSourceFilter[0] = {
						"name": "CDPAIS",
						"operator": "=",
						"value": widget.currentRow.CDPAIS
					};
					widget.getField(bairro).dataSourceFilter[1] = {
						"name": "SGESTADO",
						"operator": "=",
						"value": widget.currentRow.SGESTADO
					};
					widget.getField(bairro).dataSourceFilter[2] = {
						"name": "CDMUNICIPIO",
						"operator": "=",
						"value": widget.currentRow.CDMUNICIPIO
					};
				} else reload[2] = true;
			} else reload[1] = reload[2] = true;
		} else reload[0] = reload[1] = reload[2] = true;

		return reload;
	};

	self.validateCpfCnpj = function (widget) {

		var currentRow = widget.currentRow;

		var resultValidate = General.inscricaoFormat(currentRow.NRINSJURVEN);

		if (resultValidate.valid && resultValidate.value) {

			currentRow.NRINSJURVEN = resultValidate.value;

		} else {
			if (resultValidate.tipo.cod == 'F') {

				ScreenService.showMessage('CPF Invalido');
				currentRow.NRINSJURVEN = "";

			} else {

				ScreenService.showMessage('CNPJ Invalido');
				currentRow.NRINSJURVEN = "";

			}
		}

	};

	self.alteraGeraComissao = function (widget) {
		self.habilitaGeraComissao(widget);
		if(widget.currentRow.IDGERACOMISVEND == 'N'){
			widget.currentRow.VRPECOMVEN      = '';
			widget.currentRow.VRCOMPROVEND    = '';
			widget.currentRow.NMCOMISSAO      = '';
			widget.currentRow.CDCOMISSAO      = '';
			widget.currentRow.NMCOMISSAOPROMO = '';
			widget.currentRow.CDCOMISSAOPROMO = '';
		}
	};
	
	self.habilitaGeraComissao = function (widget) {
		if(widget.getField('IDGERACOMISVEND').value() == 'S'){
			widget.getField('VRPECOMVEN').readOnly      = false;
			widget.getField('VRCOMPROVEND').readOnly    = false;
			widget.getField('NMCOMISSAO').readOnly      = false;
			widget.getField('NMCOMISSAOPROMO').readOnly = false;
		}else{
			widget.getField('VRPECOMVEN').readOnly      = true;
			widget.getField('VRCOMPROVEND').readOnly    = true;
			widget.getField('NMCOMISSAO').readOnly      = true;
			widget.getField('NMCOMISSAOPROMO').readOnly = true;
		}
	};
	
	self.alteraUnidadeGarcom = function (widget) {
		self.habilitaCaixa(widget);
		
		widget.currentRow.CDCAIXA = null;
		widget.currentRow.NMCAIXA = null;
		
        widget.getField('NMCAIXA').reload();
	};
	
	self.habilitaCaixa = function (widget) {
		if(widget.getField('CDFILIAL').value())
			 widget.getField('NMCAIXA').readOnly = false;
		else widget.getField('NMCAIXA').readOnly = true;
	};
};

Configuration(function (ContextRegister) {
	ContextRegister.register('Ped00600_Vendedor_Controller', Ped00600_Vendedor_Controller);
});

// FILE: ./assets/js/controllers/ger00701_Relatorio_Customizavel_Cliente.js
var Ger00701_relatorioCustomizavelCliente_Controller = function(ScreenService, templateManager, Endereco, ZhFilterPreferences, General, ZHPromise, metaDataFactory, MessageService) {
    /*global Configuration, angular, getLocalVar*/
    var self = this;

    // this.startFiltering = function(widget) {
    //     var promises = [];
    //     promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
    //     promises.push(ZhFilterPreferences.openFilterWidget(widget));
    //     ZHPromise.all(promises);
    // };
    this.openFilter = function(widget) {
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter) {
            this.setFilterTipoEndereco(widget);
        }.bind(this));

    };
    
    this.setFilterTipoEndereco = function() {
        var widget = templateManager.container.getActiveWidget();
        widget.currentRow.IDTPENDECLIE = 'P';
        widget.getField('IDTPENDECLIE').setValue('P');

    };
    
    this.setDataSourceFilter = function(widget) {

        var filter = widget.appliedFilter.FILTER_ROW;
        var dataFilter = [];
        var value = null;

        // novo TIPO DE ENDEREÇO
        if (filter.IDTPENDECLIE && filter.IDTPENDECLIE.length > 0) {
            if (filter.IDTPENDECLIE != "TODOS") {
                dataFilter.push({
                    "name": "P_IDTPENDECLIE",
                    "operator": "=",
                    "value": filter.IDTPENDECLIE.toString()
                });
                dataFilter.push({
                    "name": "P_TIDTPENDECLIE",
                    "operator": "=",
                    "value": ""
                });
            } else {
                dataFilter.push({
                    "name": "P_IDTPENDECLIE",
                    "operator": "=",
                    "value": ""
                });
                dataFilter.push({
                    "name": "P_TIDTPENDECLIE",
                    "operator": "=",
                    "value": "T"
                });
            }
        } else {
            dataFilter.push({
                "name": "P_IDTPENDECLIE",
                "operator": "=",
                "value": ""
            });
            dataFilter.push({
                "name": "P_TIDTPENDECLIE",
                "operator": "=",
                "value": "T"
            });
        }

        // PAIS
        if (filter.CDPAIS && filter.CDPAIS.length > 0) {
            dataFilter.push({
                "name": "P_CDPAIS",
                "operator": "=",
                "value": filter.CDPAIS.toString()
            });
            dataFilter.push({
                "name": "P_TCDPAIS",
                "operator": "=",
                "value": ""
            });
        } else {
            dataFilter.push({
                "name": "P_CDPAIS",
                "operator": "=",
                "value": ""
            });
            dataFilter.push({
                "name": "P_TCDPAIS",
                "operator": "=",
                "value": "T"
            });
        }


        // Estado
        if (filter.SGESTADO && filter.SGESTADO.length > 0) {
            dataFilter.push({
                "name": "P_SGESTADO",
                "operator": "=",
                "value": filter.SGESTADO.toString()
            });
            dataFilter.push({
                "name": "P_TSGESTADO",
                "operator": "=",
                "value": ""
            });
        } else {
            dataFilter.push({
                "name": "P_SGESTADO",
                "operator": "=",
                "value": ""
            });
            dataFilter.push({
                "name": "P_TSGESTADO",
                "operator": "=",
                "value": "T"
            });
        }

        //CIDADE
        if (filter.CDMUNICIPIO && filter.CDMUNICIPIO.length > 0) {
            dataFilter.push({
                "name": "P_CDMUNICIPIO",
                "operator": "=",
                "value": filter.CDMUNICIPIO.toString()
            });
            dataFilter.push({
                "name": "P_TCDMUNICIPIO",
                "operator": "=",
                "value": ""
            });
        } else {
            dataFilter.push({
                "name": "P_CDMUNICIPIO",
                "operator": "=",
                "value": ""
            });
            dataFilter.push({
                "name": "P_TCDMUNICIPIO",
                "operator": "=",
                "value": "T"
            });
        }

        //CLIENTE
        if (filter.CLIENTELISTA && filter.CLIENTELISTA.length > 0) {
            dataFilter.push({
                "name": "P_CLIENTELISTA",
                "operator": "=",
                "value": filter.CLIENTELISTA.toString()
            });
            dataFilter.push({
                "name": "P_TCLIENTELISTA",
                "operator": "=",
                "value": ""
            });
        } else {
            dataFilter.push({
                "name": "P_CLIENTELISTA",
                "operator": "=",
                "value": ""
            });
            dataFilter.push({
                "name": "P_TCLIENTELISTA",
                "operator": "=",
                "value": "T"
            });
        }

        // DEFINIR DATASOURCE FILTER DO WIDGET
        widget.dataSourceFilter = dataFilter;
        widget.reload();

    };
    
    this.setDataSourceFilterField = function(field) {
        var widget = field.widget;
        if(field.name == 'SGESTADO'){
            
            var cdpais = widget.currentRow.CDPAIS;
            
            widget.getField('SGESTADO').dataSourceFilter[0].value = cdpais;
            widget.getField('SGESTADO').reload();
            
        }else if(field.name == 'CDMUNICIPIO'){
            
            var sgestado = widget.currentRow.SGESTADO;
            
            widget.getField('CDMUNICIPIO').dataSourceFilter[0].value = sgestado;
            widget.getField('CDMUNICIPIO').reload();
        }
    };
    
    this.setReadOnly = function(widget) {
        if (widget.currentRow.CDPAIS && widget.currentRow.CDPAIS.length > 0) {
            widget.getField("SGESTADO").readOnly = false;
        } else {
            widget.getField("SGESTADO").readOnly = true;
            widget.getField("CDMUNICIPIO").readOnly = true;
        }


        if (widget.currentRow.SGESTADO && widget.currentRow.SGESTADO.length > 0) {
            widget.getField("CDMUNICIPIO").readOnly = false;
        } else {
            widget.getField("CDMUNICIPIO").readOnly = true;
        }
    };
    
    this.clearDataField = function(fieldName, widget) {
        var campoDiferente = this.comparaArrays(fieldName, widget);
        if (campoDiferente) {
            if (fieldName == 'CDPAIS') {
                widget.getField('SGESTADO').setValue([]);
                widget.getField('SGESTADO').reload();
                widget.getField('CDMUNICIPIO').setValue([]);
                widget.getField('CDMUNICIPIO').reload();
            } else if (fieldName == 'SGESTADO') {
                widget.getField('CDMUNICIPIO').setValue([]);
                widget.getField('CDMUNICIPIO').reload();
            }
        }
        this.setReadOnly(widget);
        var sessionField = 'FILTRO_' + fieldName + '_OLD';
        sessionStorage.setItem(sessionField, widget.currentRow[fieldName]);
    };
    
    this.comparaArrays = function(fieldName, widget) {
        var field_new = widget.currentRow[fieldName];
        var sessionField = 'FILTRO_' + fieldName + '_OLD';
        var field_old = sessionStorage.getItem(sessionField);

        field_new = field_new.toString();
        if (field_old)
            field_old = field_old.toString();
        else field_old = '';

        if (field_new === field_old)
            return false;
        else
            return true;
    };
    
    this.getFieldValue = function(filedName, widgetName, fromFilter) {
        var container = templateManager.container;
        if (container) {
            var valuesWidget = container.getWidget(widgetName);
            if (fromFilter) {
                valuesWidget = templateManager.container.factoredWidgets.filter(function(widget){
                    return widget._filteredWidgetId == valuesWidget.id;
                })[0];
            }

            if (valuesWidget) {
                var valueField = valuesWidget.currentRow[filedName];
                return valueField || null;
            } else return null;
        } else return null;
    };
    
    this.getFieldValueTeste = function(){
        if(templateManager.container){
        var widget = templateManager.container.getActiveWidget();
        return widget.currentRow.SGESTADO.toString;
        }
    };
    
    this.teste = function(){};


    //     this.atualizafiltroEndereco = function (widget) {
    // 		var reload = [false, false];

    // 		if (widget.currentRow.CDPAIS) {
    // 			widget.getField("SGESTADO").readOnly = false;

    // 			if (widget.getField("SGESTADO").dataSourceFilter[0])
    // 				if (widget.getField("SGESTADO").dataSourceFilter[0].value != widget.currentRow.CDPAIS) reload[0] = true;

    // 			widget.getField("SGESTADO").dataSourceFilter[0] = {
    // 				"name": "CDPAIS",
    // 				"operator": "=",
    // 				"value": widget.currentRow.CDPAIS
    // 			};

    // 			if (widget.currentRow.SGESTADO) {
    // 				widget.getField("CDMUNICIPIO").readOnly = false;

    // 				if (widget.getField("CDMUNICIPIO").dataSourceFilter[0])
    // 					if (widget.getField("CDMUNICIPIO").dataSourceFilter[0].value != widget.currentRow.CDPAIS || widget.getField("CDMUNICIPIO").dataSourceFilter[1].value != widget.currentRow.SGESTADO) reload[1] = true;

    // 				widget.getField("CDMUNICIPIO").dataSourceFilter[0] = {
    // 					"name": "CDPAIS",
    // 					"operator": "=",
    // 					"value": widget.currentRow.CDPAIS
    // 				};
    // 				widget.getField("CDMUNICIPIO").dataSourceFilter[1] = {
    // 					"name": "SGESTADO",
    // 					"operator": "=",
    // 					"value": widget.currentRow.SGESTADO
    // 				};

    // 			} else reload[1] = true;
    // 		} else reload[0] = reload[1] = true;

    // 		return reload;
    // 	};


    // 	this.validaEndereco = function (widget) {

    // 	    var reload = self.atualizafiltroEndereco(widget);

    // 		if (reload[0]) {
    // 			widget.currentRow.SGESTADO = null;

    // 			if (!widget.currentRow.CDPAIS) widget.getField("SGESTADO").readOnly = true;

    // 			widget.getField("SGESTADO").reload();
    // 		}

    // 		if (reload[1]) {
    // 			widget.currentRow.CDMUNICIPIO = null;

    // 			if (!widget.currentRow.SGESTADO) widget.getField("CDMUNICIPIO").readOnly = true;

    // 			widget.getField("CDMUNICIPIO").reload();
    // 		}

    // 	};

};

Configuration(function(ContextRegister) {
    ContextRegister.register('Ger00701_relatorioCustomizavelCliente_Controller', Ger00701_relatorioCustomizavelCliente_Controller);
});

// FILE: ./assets/js/controllers/ped00900_ramo_atividade.js
/* global angular moment getLocalVar setLocalVar Configuration */
var ped00900_ramo_atividade = function(ScreenService, General, maskEngine, ZhUtil, templateManager, ped00900_ramo_Service, MessageService) {
    this.afterLoadDataSource = function(widget){
        var widgetMasc = templateManager.container.getWidget('configurarMascara');
        widget.dataSource.data.forEach(
            function (row) {
                //verifica se tem filho para exibir símbolo '>'
                if (row.POSSUI_FILHOS == 'S') {
                    row._hasChild = true;
                }
                
                
            }
        );
        if(widget.dataSource.data.length > 0){
            widgetMasc.getField('CDPICTATIVCL').readOnly = true;
        }else{
            widgetMasc.getField('CDPICTATIVCL').readOnly = false;
        }
    };
    
    this.novoRamo = function(widget){
        var widForm = widget.container.getWidget('formRamo');
        widForm.showDescriptionOrder = false;
        widForm.newRow();
        widForm.validCode = true;
        delete widForm.getField('CDATIVCLI').mask;
        widForm.getField('CDATIVCLI').readOnly = false;
        widForm.currentRow.CDNVATIVCLI = '1';
        
        if(widget.currentRow.CDATIVCLI){
            var cdAtiv = angular.copy(widget.currentRow.CDATIVCLI);
            var MASCARATIVIDADE = General.getLevelByMask('CDPICTATIVCL', 1);
            var nivelMascara = this.retornaNivelMascara(cdAtiv);
            var isMaxLevel = MASCARATIVIDADE.length == nivelMascara ? true : false;
            
            ped00900_ramo_Service.buscaNovoCodigo(cdAtiv, isMaxLevel).then(function(callback){
                if(callback){
                    widForm.getField('CDATIVCLI').setValue(callback.toString());
                    this.validaCodigo(widForm);
                }else{
                    nivelMascara = parseInt(nivelMascara);
                    var fill = MASCARATIVIDADE[nivelMascara].caracteres;
                    cdAtiv = cdAtiv.padEnd(fill, 0);
                    widForm.getField('CDATIVCLI').setValue(cdAtiv);
                    this.validaCodigo(widForm);
                }
            }.bind(this), function(error){
                ScreenService.showMessage(error.data.error);
            });
        }else{
            //widForm.getField('CDATIVCLI').setValue("0");
        }
        
        ScreenService.openSwipe(widForm);
    };
    
    this.verificaParametros = function(treeWidget){
        ped00900_ramo_Service.getParamAtivCli().then(function(callback){
            if(callback && callback.dataset && callback.dataset.paramativcli && callback.dataset.paramativcli[0] && callback.dataset.paramativcli[0].CDPICTATIVCL){
                treeWidget.getAction('novoRamo').isVisible = true;
                setLocalVar('CDPICTATIVCL', callback.dataset.paramativcli[0].CDPICTATIVCL);
                treeWidget.activate();
                treeWidget.reload();
            }else{
                var widgetMascara = templateManager.container.getWidget('configurarMascara');
                treeWidget.dataSource.data = [];
                treeWidget.getAction('novoRamo').isVisible = false;
                ScreenService.showMessage('Máscara para ramo de atividades não cadastrada! Informe a máscara na personalização do sistema', 'error').then(function(){
                    ScreenService.openPopup(widgetMascara);
                });
            }
        });
    };
    this.closeSwipes = function(widget){
        var treeWidget = widget.getParent();
        ScreenService.closeSwipe();
        treeWidget.list();
        treeWidget.activate();
    };
    
    this.verRamo = function(widget){
        var formRamo = widget.container.getWidget('formRamo');
        formRamo.currentRow = widget.currentRow;
        formRamo.bkpRow = angular.copy(widget.currentRow);
        formRamo.getField('CDATIVCLI').readOnly = true;
        formRamo.getField('CDATIVCLI').mask = {
            "type": "fix",
            "params": {
                "mask": getLocalVar('CDPICTATIVCL')
            }
        };
        formRamo.view();
        formRamo.activate();
        ScreenService.openSwipe(formRamo);
    };
    
    this.backEdit = function(widget){
        if(widget.currentRow.__is_new){
            widget.showDescriptionOrder = true;
            ScreenService.closeSwipe();
            widget.getField('CDATIVCLI').mask = {
                "type": "fix",
                "params": {
                    "mask": getLocalVar('CDPICTATIVCL')
                }
            };
        }else{
            widget.currentRow = angular.copy(widget.bkpRow);
            widget.view();
        }
    };
    
    this.salvar = function(widget){
        var cdAtiv = widget.currentRow.CDATIVCLI;
        var cdArvAtiv = cdAtiv.split('.').join('');
        widget.currentRow.CDARVATIVCLI = cdArvAtiv;
        
        var nivel = this.retornaNivelMascara(cdAtiv);
        widget.currentRow.CDNVATIVCLI = nivel;
        
        if(nivel != null){
        if(widget.isValid() && widget.validCode){
            var row = angular.copy(widget.currentRow);
            row.CDATIVCLI = row.CDATIVCLI.split('.').join('');
            row.IDTIPORAMO = row.IDTIPORAMO ? row.IDTIPORAMO : "N"; 
            ped00900_ramo_Service.insereRamoAtividade([row]).then(function(callback){
                if(callback.dataset.success){
                    widget.showDescriptionOrder = true;
                    widget.getField('CDATIVCLI').mask = {
                        "type": "fix",
                        "params": {
                            "mask": getLocalVar('CDPICTATIVCL')
                        }
                    };
                    delete widget.validCode;
                    widget.getParent().reload();
                    widget.currentRow.__is_new = false;
                    widget.view();
                }else if(callback.dataset.error){
                    ScreenService.showMessage(callback.dataset.error.message, 'error');
                }
            }, function(erro){
                ScreenService.showMessage(erro.data.error, 'error');
            });
        }
            
        }else{
            //ScreenService.showMessage("Nível incompleto, o codigo deve seguir o padrão "+getLocalVar('CDPICTATIVCL'));
            
            var var_nivelIncompleto = "nivelIncompletoMsg";
            MessageService.showMessageByCode(var_nivelIncompleto,{"CDPICTATIVCL" : getLocalVar('CDPICTATIVCL')});
            return false;
        }
    };
    
    this.editRamo = function(widget){
        widget.edit();
        widget.validCode = true;
    };
    
    this.onlyNumbers = function(field) {
        var value = field.value();
        var size = value && !isNaN(value.toString().length) ? value.toString().length : 0; 
        if(size > 0 && value[value.length-1] === '.' && field.verifyLastChar){
            value = value.slice(0, value.length-1);
            field.value(value);
        }
        field.verifyLastChar = true;
        
    };
    
    function isNumberOrLetter(event) {
        var isNumber = event.keyCode > 47 && event.keyCode < 58;
        var isLetter = (event.keyCode > 64 && event.keyCode < 91) ||
                       (event.keyCode > 96 && event.keyCode < 123);
        return isNumber || isLetter;
    }
    function isNumber(event){
        return event.keyCode > 47 && event.keyCode < 58;
    }
    
    this.formataMascara = function(field) {
        var value = field.value();
        var positionInsert = event.target.selectionStart;
        var tamCampo = !value || !value.toString().length ? 1 : value.toString().length+1; 
            /* 
               Adiciona-se 1 pois field.value() não considera o valor que 
               disparou o evento, e ao apagar caracteres não é dispara essa 
               função de onKeyPress
            */
        var posMask = tamCampo-1;
        var mascara = getLocalVar('CDPICTATIVCL');
        var tamMascara = mascara.length;
        field.verifyLastChar = false;
        if (tamCampo-1 === tamMascara) { // Se já tiver atingido tamanho máximo não aceita o valor digitado.
            event.returnValue = false;
            return false;
        } else {
            var caracterMascara = mascara[posMask];
            if(caracterMascara == '.' ){
                caracterMascara = mascara[posMask+1];
            }

            var tipoMascara = parseInt(caracterMascara);
            if((isNaN(tipoMascara))){ // verifica se a proxima posição da mascara aceita letra
                if (isNumberOrLetter(event)) { // verifica se o digitado foi letra ou numero
                    if(mascara[posMask] == '.'){  //se posição anterior da mascara tiver ponto, acrescenta.
                        field.value(value+'.');
                    }

                    return true;
                }
            } else { // proxima posição da mascara é número
                if (isNumber(event)){ // aceita apenas números

                    if(mascara[posMask] == '.'){
                        var fullValue = value.slice(0, positionInsert) + event.key + value.slice(positionInsert);
                        var valueFormat = fullValue.slice(0, fullValue.length-1) + '.' + fullValue.slice(fullValue.length-1);
                        field.value(valueFormat);
                        event.returnValue = false;
                        return false;
                    }

                    return true;
                } else {
                    if(event.key === '.' && mascara[posMask] == '.'){
                        return true;
                    }
                }
            }
        }

        // Se caracter especial, desconsidera valor digitado.
        event.returnValue = false;
        return false;
    };
    
    this.retornaNivelMascara = function(cdAtiv){
        var MASCARATIVIDADE = General.getLevelByMask('CDPICTATIVCL', 1);
        //valida se o código tem o tamanho de algum nível corretamente
        var tamCdRamo = cdAtiv.split('.').join('').length;
        var i = 0;
        var nivel = null;

        for (i in MASCARATIVIDADE) {
            if (tamCdRamo == MASCARATIVIDADE[i].caracteres) {
                nivel = MASCARATIVIDADE[i].nivel;
                break;
            } else {
                nivel = null;
            }

            i++;
        }
        return nivel;
    };
    
    this.validaCodigo = function (widget){
        var fieldPrato = widget.getField('CDATIVCLI');
        fieldPrato.verifyLastChar = true;
        this.onlyNumbers(widget.getField('CDATIVCLI'));
        var cdAtiv = widget.currentRow.CDATIVCLI;
        var cdArvAtiv = cdAtiv.split('.').join('');

        //valida se o código tem o tamanho de algum nível corretamente
        cdAtiv = typeof cdAtiv === 'number' ? cdAtiv.toString() : cdAtiv; 
        
        var nivel = this.retornaNivelMascara(cdAtiv);
        
        if (!nivel) {
            ScreenService.showMessage('Código incompleto.', 'error');
            widget.validCode = false;
        } else {
            widget.validCode = true;
            widget.currentRow.CDARVATIVCLI = cdArvAtiv;
            widget.currentRow.CDATIVCLI = Util.applyMask(cdAtiv, {
                type: "fix",
                params: {
                    mask: getLocalVar('CDPICTATIVCL')
                }
            }, maskEngine, ZhUtil);
            widget.currentRow.CDNVATIVCLI = nivel;
        }
        
    };
    
    this.deletarRamo = function(widget){
        var row = angular.copy(widget.currentRow);
        row.NRORG = getLocalVar('NRORG');
        row.CDATIVCLI = row.CDATIVCLI.split('.').join('');
        ScreenService.confirmMessage('Tem certeza que deseja excluir esse registro?', 'question', function(success) {
            ped00900_ramo_Service.deleteRamoAtividade([row]).then(function(callback){
                if(callback.notifications){
                    ScreenService.closeSwipe();
                    widget.getParent().activate();
                    widget.getParent().reload();
                    delete widget.currentRow.CDATIVCLI;
                }else if(callback.dataset.error){
                    ScreenService.showMessage(callback.dataset.error.message, 'error');
                }
            }, function(erro){
                ScreenService.showMessage(erro.data.error, 'error');
            });
        });
    };
    
    this.corrigeFiltro = function(widget){
        if(widget.dataSourceFilter){
            widget.dataSourceFilter.forEach(function(filtro){
                if(filtro.name === "CDATIVCLI"){
                    filtro.value = filtro.value.split('.').join('');
                }
            });
            widget.reload();
        }
    };
    
    this.openPopupConfigurarMascara = function(){
        var configurarMascaraWidget = templateManager.container.getWidget("configurarMascara");
        ScreenService.openPopup(configurarMascaraWidget);
        General.edit(configurarMascaraWidget);
    };
    
    this.atualizaForm = function(widget) {
        widget.currentRow = widget.dataSource.data[0]?widget.dataSource.data[0]:{};
        templateManager.updateTemplate();
    };
    
    this.recarregaWidget = function(widget) {
        widget.reload();
    };
    
    this.saveMascara = function(widget){
        var widgetpai = templateManager.container.getWidget('treeRamo');
        widget.currentRow.__is_new = false;
        
        if(this.validaMascara(widget)){
            General.saveCrud(widget).then(function(){
                setLocalVar('CDPICTATIVCL', widget.currentRow.CDPICTATIVCL);
                widgetpai.getAction('novoRamo').isVisible = true;
                this.fechar();
            }.bind(this));
        }
    };
    
    this.validaMascara = function(widget){
        
        var mensagem = 'Máscara invalida. ';
        var rowMascara = widget.currentRow.CDPICTATIVCL.split('.').join('');
        var tamanhoMascara = widget.currentRow.CDPICTATIVCL.length;
        var aux = false;
        
        if(widget.currentRow.CDPICTATIVCL.match(/[A-Zb-z0-8!@#$%^&*(),?":{}|<>]/g)){ 
            ScreenService.showMessage("Máscara inválida. Somente são aceitos caracteres (9), (.) e (a)." );
            return false; 
        }
        
        if(widget.currentRow.CDPICTATIVCL.split('.').join('').length > 10){
            ScreenService.showMessage("Máscara inválida. N° de caracteres válidos (9 ou a) deve ser menor ou igual a 10.");
            return false;
        }
        
        if(widget.currentRow.CDPICTATIVCL.indexOf("..")> -1){
           mensagem += "Dois pontos consecutivos. ";
           aux = true;
        }
        
        if(widget.currentRow.CDPICTATIVCL.indexOf(".") == 0){
           mensagem += "Ponto no início da máscara. ";
           aux = true;
        }
        
        if(widget.currentRow.CDPICTATIVCL.slice(-1) == '.' ){
           mensagem += "Ponto no fim da máscara. ";
           aux = true;
        }
        
        if(widget.currentRow.CDPICTATIVCL.indexOf(".") == -1 ){
           mensagem += "A máscara deve ter ao menos dois níveis.";
           aux = true;
        }
        
        

        if(aux){
            ScreenService.showMessage(mensagem);
        }else{
            return true;
        }
  
    };
    
    this.checkMascara = function(widget){
        
        var mascara = getLocalVar('CDPICTATIVCL');
        var rowMascara = mascara.split('.').join('');
        var novoRamoMasc = widget.currentRow.CDATIVCLI;
        var novoRamoMascTam = widget.currentRow.CDATIVCLI.length;
        var caracterMascara = novoRamoMasc[novoRamoMascTam-1];
        
        
        if(novoRamoMascTam<= rowMascara.length){
            if(rowMascara[novoRamoMascTam-1] == 'a'){
                if(caracterMascara.match(/[^a-z0-9]/g)){ 
                widget.getField('CDATIVCLI').setValue( widget.currentRow.CDATIVCLI.substring(0,(novoRamoMascTam-1)));
                templateManager.updateTemplate();
                return true;
                }
            }
            
            if(rowMascara[novoRamoMascTam-1] == '9'){
                if(caracterMascara.match(/[^0-9]/g)){ 
                widget.getField('CDATIVCLI').setValue( widget.currentRow.CDATIVCLI.substring(0,(novoRamoMascTam-1)));
                templateManager.updateTemplate();
                return true;
                }
            }
            
        }else{
            widget.getField('CDATIVCLI').setValue( widget.currentRow.CDATIVCLI.substring(0,(novoRamoMascTam-1)));
            templateManager.updateTemplate();
        }
    };
    
    this.formataMask = function(widget){
    
        var mascara = getLocalVar('CDPICTATIVCL');
        var novoRamo = widget.currentRow.CDATIVCLI;
        var novoRamoMask = novoRamo.split('.').join('');
        var rowMascara = mascara.split('.').join('');
        var mascaraFormatada = '';
        var j = 0;

        for(var i= 0; i<(mascara.length); i++){
           
                if(mascara[i] == '.'){
                    mascaraFormatada += '.';
                }else if(novoRamoMask[j]){
                    mascaraFormatada += novoRamoMask[j];
                    j++;
                }else{
                    i=mascara.length;
                }
        }
        
        widget.getField('CDATIVCLI').setValue(mascaraFormatada);
        templateManager.updateTemplate();
        
        var nivel = this.retornaNivelMascara(novoRamo);
        if(nivel == null && novoRamo != ""){
            ScreenService.showMessage("Nível incompleto");
        }
    };
    
    this.atualizaMascara = function(widget){
        
        var novoRamo = widget.currentRow.CDATIVCLI;
        var novoRamoMask = novoRamo.split('.').join('');
        
        if(novoRamo!= null){
            widget.getField('CDATIVCLI').setValue(novoRamoMask);
            templateManager.updateTemplate();
        }
    };
    
    
    this.checkMaskCompleta = function(widget){
        var mascara = getLocalVar('CDPICTATIVCL');
        var novoRamoMasc = widget.currentRow.CDATIVCLI;


        for(var i =0; i < novoRamoMasc.length; i++){
            if(mascara[i] == 'a'){
                if(novoRamoMasc[i].match(/[^a-z0-9]/g)){
                    //ScreenService.showMessage("O código digitado é invalido, a posição "+(i+1)+" só aceita numeros e letras (Padrão da máscara : "+mascara+")");                
                    var erroPosicaoLetra = "erroPosicaoLetraMsg";
                    MessageService.showMessageByCode(erroPosicaoLetra, {"POSICAO": (i+1), "MASCARA": mascara});
                    
                }
            }
            if(mascara[i] == '9'){
                if(novoRamoMasc[i].match(/[^0-9]/g)){
                    //ScreenService.showMessage("O código digitado é invalido, a posição "+(i+1)+" só aceita numeros (Padrão da máscara : "+mascara+")");
                    var erroPosicaoNumero = "erroPosicaoNumeroMsg";
                    MessageService.showMessageByCode(erroPosicaoNumero, {"POSICAO": (i+1), "MASCARA": mascara});
                    
                }
            }
            if(mascara[i] == '.'){
                if(novoRamoMasc[i].match(/[^.]/g)){
                    //ScreenService.showMessage("O código digitado é invalido ela deve respeitar o padrão: "+mascara);
                    var erroPadraoMascara = "erroPadraoMascaraMsg";
                    MessageService.showMessageByCode(erroPadraoMascara, {"MASCARA": mascara});
                }
            }
        }
        
        

    };
    

    this.fechar = function(){
        var widgetpai = templateManager.container.getWidget('treeRamo');
        ScreenService.closePopup();
        widgetpai.activate();
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('ped00900_ramo_atividade', ped00900_ramo_atividade);
});
